--英雄召唤 召唤主panel
checkRequire("Lua_RecruitCostItem");
checkRequire("Lua_RecruitWishHeroItem");
checkRequire("Lua_RecruitTweenState");
Lua_RecruitMainPanel = class("Lua_RecruitMainPanel", Lua_DisplayObject);

function Lua_RecruitMainPanel:ctor(p)
	self:superCall("ctor", p, "RecruitMainPanel_skin");
end

function Lua_RecruitMainPanel:buildPanel()
	self:superCall("buildPanel");

	self:addLuaEvent("UPDATE_RECRUIT_WISHLIST_INFO", self, self.updateWishListShow); 
	self:addLuaEvent("UPDATE_RECRUIT_WISHBLESS_INFO", self, self.updateWishBlessShow); 
	self:addLuaEvent("UPDATE_RECRUIT_MAIN_INFO", self, self.rRecruitInfo); 
	self:addLuaEvent("UPDATE_RECRUITMAINTYPE_SELECT", self, self.updateTypeSelect);	

	self:addLuaEvent("CLICK_SENIORRECRUIT_ONERECRUIT", self, self.onOneBtnClick);	
	self:addLuaEvent("CLICK_SENIORRECRUIT_TENRECRUIT", self, self.onTenBtnClick);	
end

function Lua_RecruitMainPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.wishBlessProcess.typeValue = 3;
	self.wishBlessProcess.fillMethodValue = 4;
	self.wishBlessProcess.fillOrigin = 2;
	self.wishBlessProcess.fillAmount = 0;

	-- self.oneBtnClIcon:setLocation(-202, 319);
	-- self.oneBtnNumLbl:setLocation(-171, 333);
	-- self.tenBtnClIcon:setLocation(141, 319);
	-- self.tenBtnNumLbl:setLocation(172, 333);

	self.rectTf:SetSiblingIndex(3);
	self.clickInterval = 1;
	self.selectIdx = 1; -- 1:高级召唤 2：友情召唤
	self.mainTypeArr = Array();
	local arr = DataCenter.recruitUtil.recruitTotalArr;
	for i = 1, arr:getSize() do
		if arr[i].isShowInMain == 1 then
			self.mainTypeArr:add(arr[i]);
		end
	end
	self.mainTypeArr:sort("mainSort", false);

	self.hasTxt:setLangValue(140327);
	self.oneBtnTxt:setLangValue(140324);
	self.tenBtnTxt:setLangValue(140325);
	self.wishBlessTxt:setLangValue(140326);

	self.friendRedIcon = Lua_RedPointIcon.new(self.bottomLeftObj, Lua_RedPointList.RecruitTabNormal);
	self.friendRedIcon:setRectAnchor(7);
	self.friendRedIcon:setLocation(-60, 240, 0);

	self.seniorRedIcon = Lua_RedPointIcon.new(self.bottomRightObj, Lua_RedPointList.RecruitTabHigh);
	self.seniorRedIcon:setRectAnchor(7);
	self.seniorRedIcon:setLocation(285, 240, 0);

	self.oneBtnBg:addClickFuntion(self, self.onOneBtnClick); -- 点击购买一次按钮
	self.tenBtnBg:addClickFuntion(self, self.onTenBtnClick); -- 点击购买十次按钮	
	self.introduceSp:addClickFuntion(self, self.onIntroduceClick); -- 招募英雄规则介绍
	self.wishBlessIcon:addClickFuntion(self, self.onWishBlessClick); -- 点击心愿祝福
	self.friendCallSp:addClickFuntion(self, self.openFirendCallBtn);-- 点击友情召唤 
	self.seniorCallSp:addClickFuntion(self, self.openSeniorCallBtn); -- 点击高级召唤
	self.rankSp:addClickFuntion(self, self.onClickRankSp); -- 点击排行榜

	self:sendMsg();
	self:addRecruitTween();

	Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sWishListInfo();
	Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sWishBlessInfo();
end

function Lua_RecruitMainPanel:sendMsg()
	Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sRecruitMain();
end

function Lua_RecruitMainPanel:dispose()
	if self.friendRedIcon ~= nil then
		self.friendRedIcon:dispose();
		self.friendRedIcon = nil;
	end
	if self.seniorRedIcon ~= nil then
		self.seniorRedIcon:dispose();
		self.seniorRedIcon = nil;
	end
	if self.wishBlessRedPoint ~= nil then
		self.wishBlessRedPoint:dispose();
		self.wishBlessRedPoint = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end
	if self.tenRedDot ~= nil then
		self.tenRedDot:dispose();
		self.tenRedDot = nil;
	end
	if self.costItemArr ~= nil then
		self.costItemArr:dispose();
		self.costItemArr = nil;
	end
	if self.mainTypeArr ~= nil then
		self.mainTypeArr:dispose();
		self.mainTypeArr:clear();
		self.mainTypeArr = nil;
	end
	self:removeRecruitTween();
	Lua_CommonUtil.removeTimer(self, self.sendMsg);
	self:endTime();
	self:superCall("dispose");
end

function Lua_RecruitMainPanel:rRecruitInfo()
	self:showWishBlessRedPoint();
	self:updateTypeShow(self.mainTypeArr[self.selectIdx]);
end

function Lua_RecruitMainPanel:updateTypeSelect(idx)
	if self.selectIdx == idx then return end;
	self.selectIdx = idx;
	self:updateTypeShow(self.mainTypeArr[idx]);
end

function Lua_RecruitMainPanel:updateTypeShow(data) 
	self.data = data;
	local isSeniorType = self.data.type == Lua_RecruitData.SENIOR;
	if isSeniorType then
		self.buttomBg:setAltas("recruit_atlas_3", "xui_xmb_widget_01");
		self.callTxt.text = LanUtil.formateStr(140328, data.advRemainTimes);
		self.heroNameSp:setEnable(true);
	else
		self.buttomBg:setAltas("recruit_atlas_3", "xui_xmb_widget_04");
		self.heroNameSp:setEnable(false);
	end
	self.wishBlessObj:SetActive(isSeniorType);
	self.wishListObj:SetActive(isSeniorType);
	self.callTxt:setEnable(isSeniorType);

	local toolVo = Lua_ToolVo.createToolVo(self.data.costId);
	local toolNum = DataCenter.packData:getItemCountById(self.data.costId);--self.data.matNum;
	if self.data.isUseGold then
		local costVo = Lua_ToolVo.createToolVo(self.data.currencyId);
		-- 是否有足够消耗品
		if toolNum < self.data.oneCost then 
			self.oneBtnClIcon:setAltas(costVo.iconAtlas, costVo.iconSprite);
			self.oneBtnClIcon:SetDimensions(costVo.iconWidth, costVo.iconHeight);
			self.oneBtnNumLbl.text = LanUtil.formateStr(140340, self.data.oneGold);
		else
			self.oneBtnClIcon:setAltas(toolVo.iconAtlas, toolVo.iconSprite);
			self.oneBtnClIcon:SetDimensions(toolVo.iconWidth, toolVo.iconHeight);
			self.oneBtnNumLbl.text = LanUtil.formateStr(140340, self.data.oneCost);
		end

		if toolNum < self.data.tenCost then
			self.tenBtnClIcon:setAltas(costVo.iconAtlas, costVo.iconSprite);
			self.tenBtnClIcon:SetDimensions(costVo.iconWidth, costVo.iconHeight);
			self.tenBtnNumLbl.text = LanUtil.formateStr(140340, self.data.tenGold);
		else
			self.tenBtnClIcon:setAltas(toolVo.iconAtlas, toolVo.iconSprite);
			self.tenBtnClIcon:SetDimensions(toolVo.iconWidth, toolVo.iconHeight);
			self.tenBtnNumLbl.text = LanUtil.formateStr(140340, self.data.tenCost);
		end
	else
		self.oneBtnClIcon:setAltas(toolVo.iconAtlas, toolVo.iconSprite);
		self.oneBtnClIcon:SetDimensions(toolVo.iconWidth, toolVo.iconHeight);
		self.oneBtnNumLbl.text = LanUtil.formateStr(140340, self.data.oneCost);

		self.tenBtnClIcon:setAltas(toolVo.iconAtlas, toolVo.iconSprite);
		self.tenBtnClIcon:SetDimensions(toolVo.iconWidth, toolVo.iconHeight);
		self.tenBtnNumLbl.text = LanUtil.formateStr(140340, self.data.tenCost);
	end

	self:endTime();
	self.freeTimeTxt:setEnable(self.data.isHaveFree);
	if self.data.isHaveFree then
		if tonumber(self.data.freeTime) == 0 then
			self.oneBtnClIcon:setEnable(false);
			self.oneBtnNumLbl:setLangValue(140304);
			self.oneBtnNumLbl:setLocation(-190, 319, 0);
			self:setRedDotOneShow(true);
		else
			self.oneBtnClIcon:setEnable(true);
			self.oneBtnNumLbl:setLocation(-171, 319, 0);
			self:startTime();
		end
		self:timeCountdown();
	else
		self.oneBtnClIcon:setEnable(true);
		self.oneBtnNumLbl:setLocation(-171, 319, 0);
	end
	self:updateCostItemShow(self.data);

	if self.data.type ~= Lua_RecruitData.SENIOR then
		self:setRedDotOneShow(false);
	end
	self:setRedDotTenShow(toolNum >= self.data.tenCost);
end

function Lua_RecruitMainPanel:updateCostItemShow(data)
	if  self.costItemArr == nil then
		self.costItemArr = Array();
	end
	for i = 1, self.costItemArr:getSize() do
		self.costItemArr[i]:setEnable(false);
	end

	local idList = data.exhibitionItem;
	for i = 1, 1 do
		if self.costItemArr[i] == nil then
			local item = Lua_RecruitCostItem.new(self.bottomRightObj);
			item:setAddBtnShow(false);
			self.costItemArr:add(item);
		end
		self.costItemArr[i]:setData(idList[i]);
		self.costItemArr[i]:setRectAnchor(7);
		self.costItemArr[i]:setLocation(233 + (i - 1) * 180, 408, 0);
		self.costItemArr[i]:setEnable(true);
		self.costItemArr[i].itemNumtxt:setLocation(-33, 12, 0);
		self.costItemArr[i].itemNumtxt.fontName = Lua_MyUISettings.defaultFontName;
		self.costItemArr[i].itemNumtxt.fontSize = 22;
		self.costItemArr[i].itemNumtxt.effectStyle = 2;
		self.costItemArr[i].itemNumtxt.colorStr = Lua_ColorDefine.transColor("FFFFFF");
  		self.costItemArr[i].itemNumtxt.effectColorStr = Lua_ColorDefine.transColor("2B3136");
		self.costItemArr[i].itemNumtxt:setEffectDistance(1, -2);

		-- self.costItemArr[i].itemNumtxt.colorStr = Lua_ColorDefine.transColorStr("FFFFFF");
		self.costItemArr[i].bg:setEnable(false);
	end

	self.costItemId = idList[1];
	self:showDiscountObj();
end

function Lua_RecruitMainPanel:showDiscountObj()
	if self.selectIdx == 1 then
		local count = DataCenter.packData:getItemCountById(self.costItemId);
		self.discountObj:SetActive(count < 10);
	elseif self.selectIdx == 2 then
		self.discountObj:SetActive(false);
	end
end

function Lua_RecruitMainPanel:startTime()
	if self.bStartTime == nil then
		self.bStartTime = true;
		Lua_CommonUtil.addTimer("timeCountdown", 1, self, self.timeCountdown);

		local delayTime = self.data.freeTime - DataCenter.roleData.serverTime;
		if delayTime > 0 then
			Lua_CommonUtil.delayCall(delayTime, self, self.sendMsg);
		end
	end
end

function Lua_RecruitMainPanel:endTime()
	if self.bStartTime then
		self.bStartTime = nil;
		Lua_CommonUtil.removeTimer(self, self.timeCountdown);
	end
end

function Lua_RecruitMainPanel:timeCountdown()
	self.remainTime = self.data.freeTime - DataCenter.roleData.serverTime;
	if self.remainTime > 0 then
		self.freeTimeTxt.text = LanUtil.formateStr(140302, Lua_TimeTransform.transSeconds6(self.remainTime, true,true));
	else
		self:endTime();
		self.freeTimeTxt:setLangValue(140303);
	end
	self:setRedDotOneShow(self.remainTime <= 0);
end

function Lua_RecruitMainPanel:setRedDotOneShow(bShow)
	if bShow then
		if self.redDot == nil then
			self.redDot = Lua_RedPointIcon.new(self.bottomLeftObj);
			self.redDot:setRectAnchor(7);
			self.redDot:setLocation(-92, 389, 0);
			self.redDot:createRedPointEff();
		end
		self.redDot:updateRedPointShow(true);
	else
		if self.redDot ~= nil then
			self.redDot:updateRedPointShow(false);
		end
	end
end

function Lua_RecruitMainPanel:setRedDotTenShow(bShow)
	if bShow then
		if self.tenRedDot == nil then
			self.tenRedDot = Lua_RedPointIcon.new(self.bottomRightObj);
			self.tenRedDot:setRectAnchor(7);
			self.tenRedDot:setLocation(240, 389, 0);
			self.tenRedDot:createRedPointEff();
		end
		self.tenRedDot:updateRedPointShow(true);
	else
		if self.tenRedDot ~= nil then
			self.tenRedDot:updateRedPointShow(false);
		end
	end
end

-- 打开友情召唤
function Lua_RecruitMainPanel:openFirendCallBtn()
	-- self.discountObj:SetActive(false);
	self.friendCallSp:setAltas("recruit_atlas_3", "xui_xmb_btn_01_p");
	self.seniorCallSp:setAltas("recruit_atlas_3", "xui_xmb_btn_02_n");

	self.rankSp:setLocation(301, -211);
	Lua_MsgUtil.callFunc("UPDATE_RECRUITMAINTYPE_SELECT", 2);
end

-- 打开高级召唤
function Lua_RecruitMainPanel:openSeniorCallBtn()
	-- self:showDiscountObj();
	-- self.discountObj:SetActive(true);
	self.friendCallSp:setAltas("recruit_atlas_3", "xui_xmb_btn_01_n");
	self.seniorCallSp:setAltas("recruit_atlas_3", "xui_xmb_btn_02_p");

	self.rankSp:setLocation(306, -333);
	Lua_MsgUtil.callFunc("UPDATE_RECRUITMAINTYPE_SELECT", 1);
end

-- 打开排行榜
function Lua_RecruitMainPanel:onClickRankSp()
	Lua_WindowUtil.openWin("Lua_RecruitShowLuckyRankWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_RecruitMainPanel:onOneBtnClick()
	if self.data == nil then return end;

	if self.data.openDailyDrawLimit and ( not (self.data.isHaveFree and self.remainTime <= 0) ) and self.data:getResidueCount() < 1 then
		OperateAlert.showLangValue(140348);
		return;
	end 
	local t = getTime()
	if self.clickTime ~= nil and t - self.clickTime < self.clickInterval then
		return;
	end
	self.clickTime = t;

	DataCenter.recruitData.selectTimes = 1;
	DataCenter.recruitData.selectType = self.data.type;
	if not (self.data.isHaveFree and self.remainTime <= 0) then
		local toolNum = DataCenter.packData:getItemCountById(self.data.costId);
		if self.data.isUseGold and toolNum < self.data.oneCost then
			if DataCenter.moneyData:isMoneyEnough(Lua_ResourcesDefine.DIAMOND, tonumber(self.data.oneGold), true, false, true) then
				self:costTips();
			end
			return;
		elseif (not self.data.isUseGold) and toolNum < self.data.oneCost then
			DataCenter.packUtil:openPathWindow(self.data.costId, false);
			return;
		end
	end

	if DataCenter.heroData:isBagEnough(DataCenter.recruitData.selectTimes) then
		if not self:bShowWishTip(false) and self:onWishBlessTip(false) then
			self:recruitOneHero();
		end
	else
		OperateAlert.showLangValue(140321);
	end
end

function Lua_RecruitMainPanel:onTenBtnClick()
	if self.data == nil then return end;

	if self.data.openDailyDrawLimit and self.data:getResidueCount() < 10 then
		OperateAlert.showLangValue(140349);
		return;
	end 
	local t = getTime()
	if self.clickTime ~= nil and t - self.clickTime < self.clickInterval then
		return;
	end
	self.clickTime = t;

	DataCenter.recruitData.selectTimes = 10;
	DataCenter.recruitData.selectType = self.data.type;
	local toolNum = DataCenter.packData:getItemCountById(self.data.costId);
	if self.data.isUseGold and toolNum < self.data.tenCost then
		if DataCenter.moneyData:isMoneyEnough(Lua_ResourcesDefine.DIAMOND, tonumber(self.data.tenGold), true, false, true) then
			self:costTips();
		end 
		return;
	elseif (not self.data.isUseGold) and toolNum < self.data.tenCost then
		DataCenter.packUtil:openPathWindow(self.data.costId, false);
		return;
	end

	if DataCenter.heroData:isBagEnough(DataCenter.recruitData.selectTimes) then
		if not self:bShowWishTip(true) and self:onWishBlessTip(true) then 
			self:recruitTenHero();
		end
	else
		OperateAlert.showLangValue(140321);
	end
end

function Lua_RecruitMainPanel:bShowWishTip(bTenRecruit)
	local result = self.selectIdx == 1 and DataCenter.recruitData:hasNoneWishHero(3); -- 高级招募并且无心愿英雄
	if result then
		local advTypeVo = DataCenter.recruitUtil:getRecTotVoById(Lua_RecruitData.SENIOR);
		local openNeedNum = DataCenter.recruitUtil:getWishListConfig("open_times");
		local bOpenWishHero = advTypeVo == nil or (advTypeVo ~= nil and advTypeVo.adv_draw_times >= openNeedNum);
		result = bOpenWishHero; -- 心愿英雄是否开启

		if result then
			self:wishHeroTip(bTenRecruit);
		end
	end

	return result;
end

function Lua_RecruitMainPanel:wishHeroTip(bTenRecruit)
	local tipData = {
		type = 2,
		btnType = 1,
		des = LanUtil.getValue(140372);
		sureLabel = LanUtil.getValue(140375);
		cancelLabel = LanUtil.getValue(140376),
		owner = self,
		sureFun = self.openRecruitWishListWindow,
		cancelFun = bTenRecruit and self.recruitTenHero or self.recruitOneHero
	};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_RecruitMainPanel:recruitOneHero()
	DataCenter.chatData:setDelayBroadcast(1025);
	DataCenter.chatData:setDelayBroadcast(1060);
	DataCenter.chatData:setDelayBroadcast(1061);
	Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sRecruitStar(self.data.type, 1);
end

function Lua_RecruitMainPanel:recruitTenHero()
	DataCenter.chatData:setDelayBroadcast(1025);
	DataCenter.chatData:setDelayBroadcast(1060);
	DataCenter.chatData:setDelayBroadcast(1061);
	Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sRecruitStar(self.data.type, 0);
end

function Lua_RecruitMainPanel:openRecruitWishListWindow()
	Lua_WindowUtil.openWin("Lua_RecruitWishListWindow", Lua_WinParam.ACTION_OPEN);
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_MsgUtil.callFunc("CLOSE_RECRUIT_SHOWHERO"); -- 关闭招募英雄窗口
end

function Lua_RecruitMainPanel:openRecruitWishBlessWindow()
	Lua_WindowUtil.openWin("Lua_RecruitWishBlessWindow", Lua_WinParam.ACTION_OPEN);
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_MsgUtil.callFunc("CLOSE_RECRUIT_SHOWHERO"); -- 关闭招募英雄窗口
end

function Lua_RecruitMainPanel:costTips()
	local packItemNum = DataCenter.moneyData:getMoney(Lua_ResourcesDefine.DIAMOND);
	local maxGold = DataCenter.recruitData.selectTimes == 1 and self.data.oneGold or self.data.tenGold
	local tipData = {
		type = 2,
		btnType = 1,
		des = LanUtil.formateStr(140315, tostring(maxGold), numberTrans(packItemNum), tostring(self.data.goldReward[1].count * DataCenter.recruitData.selectTimes),tostring(DataCenter.recruitData.selectTimes)),
		owner = self,
		sureFun = self.sureAction
	};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_RecruitMainPanel:sureAction()
	if DataCenter.heroData:isBagEnough(DataCenter.recruitData.selectTimes) then
		local times = DataCenter.recruitData.selectTimes == 10 and 0 or 1;
		if not self:bShowWishTip(times == 0) and self:onWishBlessTip(times == 0) then
			DataCenter.chatData:setDelayBroadcast(1025);
			DataCenter.chatData:setDelayBroadcast(1060);
			DataCenter.chatData:setDelayBroadcast(1061);
			Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sRecruitStar(self.data.type, times);
		end
	else
		OperateAlert.showLangValue(140321);
	end
end

function Lua_RecruitMainPanel:onWishBlessTip(bTenRecruit)
	if self.selectIdx == 1 and DataCenter.recruitUtil:openWishBlessType(false) > 1 then
		if DataCenter.recruitData:hasNoneWishHero(1) == false then
			local blessHeroId = DataCenter.recruitData.blessHeroId;
			if blessHeroId == nil or blessHeroId <= 0 then
				local tipData = {
					type = 2,
					btnType = 1,
					des = LanUtil.getValue(140377),
					sureLabel = LanUtil.getValue(140375),
					cancelLabel = LanUtil.getValue(140376),
					owner = self,
					sureFun = self.openRecruitWishBlessWindow,
					cancelFun = bTenRecruit and self.recruitTenHero or self.recruitOneHero
				};
				Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
				return false;
			end
		else
			local tipData = {
				type = 2,
				btnType = 1,
				des = LanUtil.getValue(140378),
				sureLabel = LanUtil.getValue(140375),
				cancelLabel = LanUtil.getValue(140376),
				owner = self,
				sureFun = self.openRecruitWishListWindow,
				cancelFun = bTenRecruit and self.recruitTenHero or self.recruitOneHero
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
			return false;
		end
	end
	return true;
end

-- 打开英雄招募规则窗口
function Lua_RecruitMainPanel:onIntroduceClick()
	Lua_WindowUtil.openWin("Lua_RecruitIntroduceWindow", Lua_WinParam.ACTION_OPEN);
end

-- 添加招募动画
function Lua_RecruitMainPanel:addRecruitTween()
	Lua_RecruitTweenState.addTweenObj(self.tipsObj);
	Lua_RecruitTweenState.addTweenObj(self.topRightObj);
	Lua_RecruitTweenState.addTweenObj(self.bottomLeftObj);
	Lua_RecruitTweenState.addTweenObj(self.bottomRightObj);
end

-- 移除招募动画
function Lua_RecruitMainPanel:removeRecruitTween()
	Lua_RecruitTweenState.removeTween(self.tipsObj, "recruit_movingUI");
	Lua_RecruitTweenState.removeTween(self.topRightObj, "recruit_movingUI");
	Lua_RecruitTweenState.removeTween(self.bottomLeftObj, "recruit_movingUI");
	Lua_RecruitTweenState.removeTween(self.bottomRightObj, "recruit_movingUI");
end













-------------------------心愿单-------------------------

function Lua_RecruitMainPanel:updateWishListShow()
	self.wishListInfo = DataCenter.recruitData.wishListInfo;

	if self.wishHeroArr == nil then
		self.wishHeroArr = Array();
	end

	local item;
	for i = 1, DataCenter.recruitUtil:getWishListConfig("amount") do
		item = self.wishHeroArr[i];
		if item == nil then
			item = Lua_RecruitWishHeroItem.new(self.wishListObj, 1);
			item:setLocation(-200 + (i - 1) * 208, 680, 0);
			self.wishHeroArr:add(item);
		end
		item:setData(self.wishListInfo[i]);
	end
end












-------------------------心愿祝福-------------------------

function Lua_RecruitMainPanel:updateWishBlessShow(msg)
	DataCenter.recruitData.blessHeroId = msg.hero_id;
	self.wishBlessInfo = msg;
	
	if msg.hero_id ~= 0 then
		local heroVo = Lua_HeroVo.new(msg.hero_id);
		self.wishBlessIcon:SetDimensions(76, 76);
		self.wishBlessIcon:setAltas(heroVo.avatar_atlas_1, heroVo.avatar_sprite_1);
	else
		self.wishBlessIcon:SetDimensions(44, 44);
		self.wishBlessIcon:setAltas("recruit_atlas_3", "xui_xmb_progress_01_a");
	end
	self.wishBlessNumTxt.text = LanUtil.formateStr(140338, msg.wish_num, msg.wish_limit);
	self.wishBlessProcess.fillAmount =  msg.wish_num/msg.wish_limit;
end

function Lua_RecruitMainPanel:onWishBlessClick()
	if DataCenter.recruitUtil:openWishBlessType(true) > 1 then
		Lua_WindowUtil.openWin("Lua_RecruitWishBlessWindow", Lua_WinParam.ACTION_OPEN);
	end
end

-- 老客回顾红点
function Lua_RecruitMainPanel:showWishBlessRedPoint()
	if self.wishBlessRedPoint == nil then
		self.wishBlessRedPoint = Lua_RedPointIcon.new(self.wishBlessObj, Lua_RedPointList.RecruitTabHighWishBless);
		self.wishBlessRedPoint:setRectAnchor(1);
		self.wishBlessRedPoint:setLocation(335, -160, 0);
	end
end