--英雄召唤 主界面
checkRequire("Lua_DialogueBubbleItem");
checkRequire("Lua_RecruitMainPanel");
checkRequire("Lua_RecruitScoutPanel");
checkRequire("Lua_RecruitTweenState");
Lua_RecruitMainWindow = class("Lua_RecruitMainWindow", Lua_Window);
function Lua_RecruitMainWindow:ctor()
	self:superCall("ctor");

	self.isFullSizeWin = true;
	self.isFullPaving = true;
	self.showBlackMask = true;
    self.showBackBtn = true;--显示返回按键
    self.skinName = "RecruitMainWindow_skin";
    self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;

    self.windowName = "Lua_RecruitMainWindow";
    self:preLoadSelfRes();
end

-- 预加载资源
function Lua_RecruitMainWindow:preLoadSelfRes()
	-- Lua_RecruitMainPanel 招募：友情招募、高级招募 预加载
	self:addPreLoadRes("/images/recruit/ui_xmb_bg_01.jpg", Lua_LoadFileType.IMG);
	self:addPreLoadRes("/images/recruit/ui_xmb_bg_04.png", Lua_LoadFileType.IMG);
end

function Lua_RecruitMainWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winBottomObj = UICreate.createGameObject(self.content, 0, 60.5, 0);
	self.winBottomObj.name = "winBottomObj";
	self.winBottomObj:AddComponent(typeof(UnityEngine.RectTransform));
	LuaUtil.setRectSize(self.winBottomObj, 720, 121);
	LuaUtil.setObjAnchor(self.winBottomObj, Lua_WindowUtil.getAnchor(7));
	self.backBtn:setParent(self.winBottomObj);

    self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content)
    self.roleInfoPanel.content.name = "roleInfoPanel";
    self.roleInfoPanel:setRectAnchor(1)

	self.panelList = {};
	self.selectIndex = 0;

	self.downBg = UICreate.createUIAtlasImage(self.winBottomObj, "common_altas_1", "ui_common_widget_005", 0, 0, 720, 121);
	self.downBg.pivot = Lua_WindowUtil.getPivot(7);
	self.downBg.anchor = Lua_WindowUtil.getAnchor(7);
	self.downBg:setLocation(0, -5, 0);

	self.panelArr = Array();
	self.panelArr:add({index = self.panelArr:getSize() + 1, textAtlas = "recruit_atlas_2", textUnOpenSprite = "xui_xmb_zgnbutton_1_d", textNormalSprite = "xui_xmb_zgnbutton_1_n", textSelectedSprite = "xui_xmb_zgnbutton_1_p", panel = Lua_RecruitMainPanel, textStr = LanUtil.getValue(140300), redPointId = Lua_RedPointList.RecruitTab});
	self.panelArr:add({index = self.panelArr:getSize() + 1, textAtlas = "recruit_atlas_2", textUnOpenSprite = "xui_mhj_zgnbutton_1_d", textNormalSprite = "xui_mhj_zgnbutton_1_n", textSelectedSprite = "xui_mhj_zgnbutton_1_p", panel = Lua_RecruitScoutPanel,   textStr = LanUtil.getValue(140301), openId = 10078});


	local count = self.panelArr:getSize();
    local width = count > 4 and 680 or count * 120;
	self.panelTabList = Lua_DragList.new(self.winBottomObj, width, 108, Lua_AxisDefine.Horizontal);
	self.panelTabList:setLocation(-width / 2, 52, 0);
	self.panelTabList:setRectAnchor(8);
	self.panelTabList.pivot = -1;
	self.panelTabList:setListCell(Lua_RecruitMainItem, 120, 108, 1);
	self.panelTabList:setArrayData(self.panelArr);
	self.panelTabList.canDrag = false;

	self.backBtn.siblingIndex = -1;
	self:addRecruitTween();
	self:showEffect(true, "xiaomaibu", -71, -1160);
	self:createDialogueBubble();
	self:addLuaEvent("RECRUIT_OPEN_MASK", self, self.showRecruitMask); --盲盒机招募时遮罩
	self:addLuaEvent("RECRUIT_SELECT_PLANE", self, self.changePanel); 
end

function Lua_RecruitMainWindow:showWin(param)
	self:superCall("showWin", param);

	local index = 1;
	if type(param) == "number" then
		index = param;
	elseif type(param) == "table" and param.main_id ~= nil then
		index = param.main_id;
	end
	self.panelTabList:moveToIndex(index);
	self.panelTabList:setSelected(index);
	self.panelTabList:setSelectClick(index);
end

function Lua_RecruitMainWindow:createDialogueBubble()
	local bubbleId, type = DataCenter.shopUtil:getBubbleIdAndType(self.classname);
	self.dialogueBubbleItem = Lua_DialogueBubbleItem.new(self.content, type);
	self.dialogueBubbleItem:setData(bubbleId);
	self.dialogueBubbleItem:setSiblingIndex(self.uiEffect.siblingIndex + 1);
end

function Lua_RecruitMainWindow:changePanel(val)
	if self.selectIndex == val then
		return; 
	end

	if self.selectIndex ~= nil then
		self.panel = self.panelList[self.selectIndex];
		if self.panel ~= nil then
			self.panel:setEnable(false);
		end
	end
	self.selectIndex = val;

	local data = self.panelArr[val];

	self.panel = self.panelList[val];
	if self.panel == nil then
		self.panel = data.panel.new(self.content);
		self.panel:setRectAnchor(9);
		self.panelList[val] = self.panel;
	else
		self.panel:setEnable(true);
	end
	
	self.panel:setSiblingIndex(4);
	if self.panel.setData ~= nil then
		self.panel:setData(data.data);
	end

	self.roleInfoPanel:setEnable(val ~= 2)
	self:showMask(val == 2)
	if self.tweenName ~= nil then
		DataCenter.winTweenManager:removeWinTween(self.tweenName);
	end
	self.tweenName = DataCenter.winTweenManager:createWinTween(self.panel.classname, self.content.transform)
end

function Lua_RecruitMainWindow:showMask(value)
	if value then
		if self.panelMask == nil then
			self.panelMask = UICreate.createUIAtlasImage(self.content, "common_altas_1", "black_mask", 0, 0, 2048, 2048)
			self.panelMask.alpha = 0.9
		end
		self.panelMask.siblingIndex = self.panel.siblingIndex
		self.panelMask:setEnable(true)
	else
		if self.panelMask then
			self.panelMask:setEnable(false)
		end
	end
end

-- 添加招募动画
function Lua_RecruitMainWindow:addRecruitTween()
	if self.winBottomObj then
		Lua_RecruitTweenState.addTweenObj(self.winBottomObj);
	end
	if self.roleInfoPanel then
		Lua_RecruitTweenState.addTweenObj(self.roleInfoPanel.content);
	end
end

-- 移除招募动画
function Lua_RecruitMainWindow:removeRecruitTween()
	if self.winBottomObj then
		Lua_RecruitTweenState.removeTween(self.winBottomObj, "recruit_movingUI");
	end
	if self.roleInfoPanel then
		Lua_RecruitTweenState.removeTween(self.roleInfoPanel.content, "recruit_movingUI");
	end
end

function Lua_RecruitMainWindow:showRecruitMask(bShow)
    if bShow then
        if self.recruitMaskBg == nil then
            self.recruitMaskBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "black_mask", 0, 0, 2048, 2048);
            self.recruitMaskBg.name = "recruitMaskBg";
            self.recruitMaskBg.alpha = 0.1;
            self.recruitMaskBg:addClickFuntion(self, self.onClickRecruitMaskBg);
        end
        self.recruitMaskBg:setEnable(true);
        Lua_CommonUtil.removeTimer(self, self.showRecruitMask);
        Lua_CommonUtil.delayCall(2.2, self, self.showRecruitMask, false);
    else
        if self.recruitMaskBg ~= nil then
            self.recruitMaskBg:setEnable(false);
        end
    end
end

function Lua_RecruitMainWindow:onClickRecruitMaskBg()
	OperateAlert.showLangValue(140370);
end

function Lua_RecruitMainWindow:showEffect(bShow, effectName, posX, posY)
	if bShow then
		local _effectName = effectName or "xiaomaibu";
		local _url = "/effects/uiEffects/".._effectName;
		local _posX = posX or 0;
		local _posY = posY or 0;
		if self.uiEffect == nil then
	  		self.uiEffect = UICreate.createUIEffect(self.content, _url, _effectName, _posX, _posY);
	  		self.uiEffect.anchorValue = 1;
	  		self.uiEffect.siblingIndex = 1;
	  	else
	  		self.uiEffect:setUrl(_url, _effectName);
	  		self.uiEffect:setLocation(_posX, _posY);
	   	end
	   	self.uiEffect:setEnable(true);
	else
		if self.uiEffect ~= nil then
			self.uiEffect:setEnable(false);
		end
	end
end

function Lua_RecruitMainWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.showRecruitMask);
	self:removeRecruitTween();

	if self.dialogueBubbleItem ~= nil then
		self.dialogueBubbleItem:dispose();
		self.dialogueBubbleItem = nil;
	end
	if self.roleInfoPanel then
		self.roleInfoPanel:dispose()
		self.roleInfoPanel = nil
	end
	if self.panelArr ~= nil then
		self.panelArr:clear();
		self.panelArr = nil;
	end
	if self.panelList ~= nil then
		for k, panel in pairs (self.panelList) do
			panel:dispose();
			self.panelList[k] = nil;
		end
		self.panelList = nil;
	end
	if self.panelTabList ~= nil then
		self.panelTabList:dispose();
		self.panelTabList = nil;
	end
	if self.downBg ~= nil then
		self.downBg:dispose();
		self.downBg = nil;
	end
	if self.winBottomObj ~= nil and IsNil(self.winBottomObj) == false then
		UnityEngine.GameObject.Destroy(self.winBottomObj);
		self.winBottomObj = nil;
	end

    if self.recruitMaskBg ~= nil then
        self.recruitMaskBg:dispose();
        self.recruitMaskBg = nil;
    end
    if self.uiEffect ~= nil then
    	self.uiEffect:dispose();
    	self.uiEffect = nil;
    end
	DataCenter.winTweenManager:removeWinTween(self.tweenName);
	self.tweenName = nil;
	self:superCall("dispose");
end



-- 检测引导数据
function Lua_RecruitMainWindow:checkWinGuide()
    self:superCall("checkWinGuide");
end

-- 引导同步
function Lua_RecruitMainWindow:updateGuide(guideId, info)
    if info == nil or self.selectIndex == nil then
        return;
    end

    local operateVal = info.operateVal; -- 操作行为参数
    if operateVal == nil then
        return;
    end

    local selectPanel = tonumber(info.selectPanel);
    if operateVal == 1 then -- 小卖部页签
		selectPanel = selectPanel or 1;
		if self.selectIndex == selectPanel then
			DataCenter.guideCommonData.winGuideResult = 1;
            Lua_MsgUtil.callFunc("Guide_WinSync_Complete", guideId);
		else
			local len = self.panelTabList.showList:getSize();
			if len >= selectPanel then
				local item = self.panelTabList.showDragDataList:getItem(selectPanel).cell;
				if item ~= nil then
					item:checkCellPressInGuide(true, guideId);
					DataCenter.guideCommonData.guideClickObjTarget = item.content;
					DataCenter.guideCommonData.guideSceneId = nil; -- 场景
					Lua_MsgUtil.callFunc("Guide_WinSync_Complete", guideId);
				end
			end
		end
    end
end











Lua_RecruitMainItem = class("Lua_RecruitMainItem", Lua_ListCell);
function Lua_RecruitMainItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RecruitMainItem:buildShowItem()
	self:superCall("buildShowItem");

	self.tabIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_button_001_b", 0, 0, 108, 118);
	self.splitSp = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_line_001", -60, 0, 2, 108);
end

function Lua_RecruitMainItem:dispose()
	if self.nameTxt ~= nil then
		self.nameTxt:dispose();
		self.nameTxt = nil;
	end
	if self.tabIcon ~= nil then
		self.tabIcon:dispose();
		self.tabIcon = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	if self.selectedSp ~= nil then
		self.selectedSp:dispose();
		self.selectedSp = nil;
	end
	self:superCall("dispose");
end

function Lua_RecruitMainItem:setData(data)
	if data == nil then
		return;
	end

	self.data = data;
	local sprite = self:getShowSprite();
	if sprite ~= nil then
		self.tabIcon:setAltas(self.data.textAtlas, sprite);
		-- self.tabIcon:resetSize();
		if self.nameTxt ~= nil then
			self.nameTxt.text = nil;
		end
	elseif self.data.textStr ~= nil then
		if self.nameTxt == nil then
			self.nameTxt = UICreate.createLabel(self.content, "", 0, 0, 118, 108, 26);
			self.nameTxt.alignmentValue = 4;
			-- self.nameTxt.colorStr = Lua_ColorDefine.transColorStr("ffe7b3");
		end
		self.nameTxt.text = self.data.textStr;
	end
	self.tabIcon:setEnable(sprite ~= nil);

	self:showRedDot(data.redPointId);
end

function Lua_RecruitMainItem:getShowSprite(bSelect)
	if self.data.textAtlas ~= nil then
		local sprite;
		if not self:checkOpened(false) then
			sprite = self.data.textUnOpenSprite;
		elseif bSelect then
			sprite = self.data.textSelectedSprite;
		else
			sprite = self.data.textNormalSprite;
		end
		return sprite;
	end
end

function Lua_RecruitMainItem:checkOpened(bShowtip)
	return DataCenter.funcOpenData:isOpened(self.data.openId, bShowtip);
end

function Lua_RecruitMainItem:onPressClick()
	self:superCall("onPressClick");
	if self.clickTime ~= nil and getTime() - self.clickTime < 1 then
        return;
    end
    self.clickTime = getTime();

    local bOpened = self:checkOpened(true);
    if not bOpened then
    	return;
    end

	Lua_MsgUtil.callFunc("RECRUIT_SELECT_PLANE", self.data.index);
	self:checkGuideCellState();
	return true;
end

function Lua_RecruitMainItem:onSelectionChange(bSelect)
    self:superCall("onSelectionChange",bSelect)

    local bOpened = self:checkOpened(false);
    if not bOpened then
    	return;
    end
    local sprite = self:getShowSprite(bSelect);
    self.tabIcon:setAltas(self.data.textAtlas, sprite);
    -- self.tabIcon:resetSize();
    self:showSelectSp(bSelect);
end

function Lua_RecruitMainItem:showSelectSp(bShow)
	if bShow then
		if self.selectedSp == nil then
			self.selectedSp = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_button_001_b", 0, 0, 118, 108);
			self.selectedSp.siblingIndex = self.tabIcon.siblingIndex;
		end
		self.selectedSp:setEnable(true);
	else
		if self.selectedSp ~= nil then
			self.selectedSp:setEnable(false);
		end
	end
end

function Lua_RecruitMainItem:showRedDot(redPointId)
	if redPointId ~= nil and self.redPoint == nil then
		self.redPoint = Lua_RedPointIcon.new(self.content, redPointId);
		self.redPoint:setLocation(41, 40, 0);
	end
end

-- 引导用
function Lua_RecruitMainItem:checkCellPressInGuide(bGuide, guideId)
    self.bPressCell = bGuide;
    self.guideId = guideId;
end

-- 引导用
function Lua_RecruitMainItem:checkGuideCellState()
    if self.bPressCell and self.guideId then
        DataCenter.guideCommonData.winGuideResult = 1;
        Lua_MsgUtil.callFunc("Guide_WinSync_Complete", self.guideId);
        self:checkCellPressInGuide(nil, nil);
    end
end