checkRequire("Lua_RecruitShowHeroItem")
Lua_RecruitShareHeroWindow = class("Lua_RecruitShareHeroWindow", Lua_Window);
function Lua_RecruitShareHeroWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_RecruitShareHeroWindow";
	self.isFullSizeWin = true;
	self.isFullSizeBg = true
	self.showWinBg = true;
	self.winBgPath = "/images/recruit/ui_xmb_bg_03.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_RecruitShareHeroWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:setHeroPosList();

	self.luckSp = UICreate.createUIAtlasImage(self.content, "recruit_atlas_2", "xui_xmb_zi_1", 210, -1136, 130, 40);
	self.luckSp.anchorValue = 1;

	self.closeText = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_button_015", 0, 41, 0, 0);
	self.closeText.name = "closeImgTip";
	self.closeText.anchorValue = 7;

	self.luckyValueTxt = UICreate.createLabel(self.content, nil, 220, -1181, 100, 66, 26);
	self.luckyValueTxt.name = "luckyValueTxt";
	self.luckyValueTxt.fontSize = 30;
	self.luckyValueTxt.colorStr = Lua_ColorDefine.transColorStr("FFFFFF");
	self.luckyValueTxt.fontName = Lua_MyUISettings.fangzhengFontName;
	self.luckyValueTxt.alignmentValue = 5;
	self.luckyValueTxt.anchorValue = 1;
	self.luckyValueTxt.horizontalOverflowValue = 1;

	self.winBg:addClickFuntion(self, self.hide);
	self:addLuaEvent("RECRUIT_SHOWHERO_SCENE", self, self.recruitItemClickfunc); -- item点击返回事件，展示英雄界面
end

function Lua_RecruitShareHeroWindow:setHeroPosList()
	self.posList = {
		{-226, -311 },
		{ 0  , -160 },
		{ 223, -311 },
		{-226, -616 },
		{ 0  , -465 },
		{ 223, -615 },
		{-226, -924 },
		{ 0  , -774 },
		{ 223, -927 },
		{ 0  , -1077},
		{ 0  , -632 }
	}
end

-- function Lua_RecruitShareHeroWindow:onAvatarClick()
-- 	if self.playerId == nil then
-- 		return;
-- 	end

-- 	if DataCenter.roleData.roleId == tonumber(self.playerId) then
-- 		OperateAlert.showLangValue(140364);
-- 	else
-- 		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self.playerId);
-- 	end
-- end

function Lua_RecruitShareHeroWindow:showWin(param)
	self:superCall("showWin",param);

	if self.heroList == nil then
		self.heroList = {};
	end
    -- 获得的英雄
    local heroInfoArr, flashList = DataCenter.recruitData:showFlashHeroItemList(param);
    local count = heroInfoArr:getSize();
    local obj;
    local item;
    local position;
	if count >= 0 then
        if count == 10 then
        	for i = 1, count do
        		obj = heroInfoArr[i];
        		position = self.posList[i];
        		item = self:getItem(i);
        		item:setData(obj, false);
        		item:setLocation(position[1], position[2]);
    			item:showShareEffect(false);
        	end
        elseif count == 1 then
        	obj = heroInfoArr[count];
    		position = self.posList[11];
    		item = self:getItem(count);
    		item:setData(obj, true);
    		item:setLocation(position[1], position[2]);
    		item:showShareEffect(true);
        end

        if flashList ~= nil and #self.heroList > 0 then
        	local obj;
        	for i = 1, #flashList do
        		obj = flashList[i];
        		item = self.heroList[obj.pos];
        		if item ~= nil then
        			item:showFlashCardDisplay();
        		end
        	end
        end

        for i = count + 1, #self.heroList do
        	self.heroList[i]:setEnable(false);
        end
	end

	self.luckyValueTxt.text = param.luck_num;
end

function Lua_RecruitShareHeroWindow:getItem(index)
	local item = self.heroList[index];
	if item == nil then
		item = Lua_RecruitShowHeroItem.new(self.content);
		item:setRectAnchor(1);
		self.heroList[index] = item;
	end
	item:setEnable(true);
	return item;
end

function Lua_RecruitShareHeroWindow:recruitItemClickfunc(heroId)
	self:showScene(heroId);
end

function Lua_RecruitShareHeroWindow:showScene(heroId)
	local heroVo;
	local replaceCfg = DataCenter.heroUtil:getHeroReplaceStarCfg(heroId);
	if replaceCfg ~= nil then
        heroVo = Lua_ToolVo.createToolVo(replaceCfg.hero_id);
        heroVo.quality = replaceCfg.quality;
        heroVo.quality_star = replaceCfg.quality_star;
    else
    	heroVo = Lua_HeroVo.new(heroId);
    end

	DataCenter.preLoadData:preShowModelScene("Lua_RecruitShowSingleHeroWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onShowModel, heroVo, heroVo);
end

function Lua_RecruitShareHeroWindow:onShowModel(param, modelScenePanel)
    param.modelScenePanel = modelScenePanel;
    Lua_WindowUtil.openWin("Lua_RecruitShowSingleHeroWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_RecruitShareHeroWindow:removeShowModel()
    DataCenter.preLoadData:removeBySign("Lua_RecruitShowSingleHeroWindow", self, self.onShowModel);
end

function Lua_RecruitShareHeroWindow:dispose()
	self:removeShowModel();
	if self.closeText ~= nil then
		self.closeText:dispose();
		self.closeText = nil;
	end
	if self.luckyValueTxt ~= nil then
		self.luckyValueTxt:dispose();
		self.luckyValueTxt = nil;
	end
	if self.luckSp ~= nil then
		self.luckSp:dispose();
		self.luckSp = nil;
	end
	if self.posList ~= nil then
		self.posList = nil;
	end
	if self.heroList ~= nil then
		for i = 1, #self.heroList do
			self.heroList[i]:dispose();
			self.heroList[i] = nil;
		end
		self.heroList = nil;
	end

	self:superCall("dispose");
end