-- 友情招募,高级招募 英雄item
Lua_RecruitShowHeroItem = class("Lua_RecruitShowHeroItem", Lua_DisplayObject);
function Lua_RecruitShowHeroItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_RecruitShowHeroItem:buildShowItem()
	self:superCall("buildShowItem");
	
	self.flashItem = Lua_CommonFlashCardItem.new(self.content);
	self.flashItem.canRotate = false; -- 是否可旋转
	self.flashItem:setCallBack(self, self.onPressClick);
end

function Lua_RecruitShowHeroItem:setData(data, isSingle)
	if data == nil then
		return;
	end

	if not isSingle then
		self:showShakeEffect(false);
		self:showIdleEffect(false);
	end
	self:showFlashSp(false, isSingle);
	local flashId = data.cardList[1];
	if flashId ~= nil then
		if isSingle then
			self.flashItem:setScale(0.54, 0.54);
		else
			self.flashItem:setScale(0.26, 0.26);
		end
		local flashInfo = Lua_FlashCardVo.new(flashId);
		self.flashItem:setData(flashInfo);
	end
	self.recruitType = data.recruitType;
	self.flashCardId = data.recruitFlashId;
	self.heroId = data.id;
	self.qualityLevel = data.color - 1;
end

function Lua_RecruitShowHeroItem:showFlashSp(value, isSingle)
	if value then
		if not self.flashSp then
			local scaleFac = isSingle and 1 or 0.6;
			local posX = isSingle and -149 or -66;
			local posY = isSingle and  234 or 115;
			self.flashSp = UICreate.createUIAtlasImage(self.content, "recruit_atlas_2", "xui_xmb_tab_1", posX, posY, 144 * scaleFac, 87 * scaleFac);
			self.flashSp.name = "flashSp";
		end
		self.flashSp:setEnable(true);
	else
		if self.flashSp ~= nil then
			self.flashSp:setEnable(false);
		end
	end
end

function Lua_RecruitShowHeroItem:showPageMask(bShow)
	if bShow then
		if self.pageMaskSp == nil then
			self.pageMaskSp = UICreate.createUIAtlasImage(self.content, "recruit_atlas_3", "xui_xmb_widget_2", 0, 0, 185, 265);
		end
		self.pageMaskSp:setEnable(true);
	else
		if self.pageMaskSp ~= nil then
			self.pageMaskSp:setEnable(false);
		end
	end
end

-- 特效 摇晃
function Lua_RecruitShowHeroItem:showShakeEffect(isShow, effectName, playTime, bDelDelayCall)
	-- if isShow then
	-- 	self.flashItem:setEnable(false);
	-- 	self:showPageMask(false);
	-- 	self:showBaseEffect(true, effectName, 0, 0, 4, 1);
	-- 	if playTime then
	-- 		Lua_CommonUtil.delayCall(playTime - 0.02, self, self.showShakeEffect, false);
	-- 	end
	-- else
	-- 	if self.uiEffect ~= nil then
	-- 		self:showPageMask(true);
	-- 		self.flashItem:setEnable(true);
	-- 		self:showBaseEffect(false);
	-- 		if bDelDelayCall then
	-- 			Lua_CommonUtil.removeTimer(self, self.showShakeEffect);
	-- 		end
	-- 	end
	-- end
end

function Lua_RecruitShowHeroItem:showIdleDisplay()
	self.tweenIndex = 1;
	self:showIdleEffect(true);
	self:showFlashCardDisplay();
end

function Lua_RecruitShowHeroItem:showFlashCardDisplay()
	self:showFlashSp(self.flashCardId ~= nil, self.recruitType == 1);
end

-- 特效 待机
function Lua_RecruitShowHeroItem:showIdleEffect(isShow)
	if isShow then
		self:showPageMask(false);
		local keyStr = "duochou_quality_effect_"..self.qualityLevel;
		local config = getConfig("recruit_tween", keyStr, "arr_value")[self.tweenIndex];
		if config ~= nil then
			local effectName = config[3];
			local facScale = config[2] or 1;
			local playTime = config[1] or 1;
			self:showBaseEffect(true, effectName, 0, 0, 4, facScale);
			if self.tweenIndex == 1 then
				Lua_CommonUtil.removeTimer(self, self.showIdleEffect);
				Lua_CommonUtil.delayCall(playTime, self, self.showIdleEffect, true);
			end
			if self.flashCardId ~= nil then
				self.tweenIndex = self.tweenIndex + 2;
			else
				self.tweenIndex = self.tweenIndex + 1;
			end
		end
	else
		Lua_CommonUtil.removeTimer(self, self.showIdleEffect);
		self:showBaseEffect(false);
	end
end

function Lua_RecruitShowHeroItem:onPressClick()
	Lua_MsgUtil.callFunc("RECRUIT_SHOWHERO_SCENE", self.heroId);
end

function Lua_RecruitShowHeroItem:showShareEffect(isSingle)
	if isSingle then
		local keyStr = "danchou_quality_effect_"..self.qualityLevel;
		local qualityEffect = getConfig("recruit_tween", keyStr, "arr_value");
		local effectName = qualityEffect[3];
		local facScale = 1;
		-- local config;
		if self.flashCardId ~= nil then
			local config = getConfig("recruit_tween", "danchou_5");
			effectName = config.effectName;
			facScale = config.facScale;
		end
		self:showBaseEffect(true, effectName, 0, 0, 4, facScale);
	else
		local tweenIndex = 2;
		if self.flashCardId ~= nil then
			tweenIndex = 3;
		end

		local keyStr = "duochou_quality_effect_"..self.qualityLevel;
		local config = getConfig("recruit_tween", keyStr, "arr_value")[tweenIndex];
		if config ~= nil then
			local effectName = config[3];
			local facScale = config[2] or 1;
			self:showBaseEffect(true, effectName, 0, 0, 4, facScale);
		end
	end
end

function Lua_RecruitShowHeroItem:showBaseEffect(bShow, effectName, posX, posY, anchorValue, facScale)
	if bShow then
		local url = "/effects/uiEffects/"..effectName;
		if self.uiEffect == nil then
			self.uiEffect = UICreate.createUIEffect(self.content, url, effectName, 0, 0);
		else
			self.uiEffect:setUrl(url, effectName);
		end

		local _posX = posX or 0;
		local _posY = posY or 0;
		local _anchor = anchorValue or 4;
		local _facScale = facScale or 1;
		self.uiEffect:setLocation(_posX, _posY);
		self.uiEffect.anchorValue = _anchor;
		self.uiEffect:setScale(_facScale, _facScale);
		self.uiEffect:setEnable(true);

		if self.flashSp ~= nil then
			self.flashSp.siblingIndex = 4;
		end
	else
		if self.uiEffect ~= nil then
			self.uiEffect:setEnable(false);
		end
	end
end

function Lua_RecruitShowHeroItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.showIdleEffect);
	Lua_CommonUtil.removeTimer(self, self.showShakeEffect);
	if self.flashItem ~= nil then
		self.flashItem:dispose();
		self.flashItem = nil;
	end
	if self.flashSp ~= nil then
		self.flashSp:dispose();
		self.flashSp = nil;
	end
	if self.pageMaskSp ~= nil then
		self.pageMaskSp:dispose();
		self.pageMaskSp = nil;
	end
	if self.uiEffect ~= nil then
		self.uiEffect:dispose();
		self.uiEffect = nil;
	end

	self:superCall("dispose");
end