checkRequire("Lua_RecruitShowHeroItem")
checkRequire("Lua_RecruitTweenState");
Lua_RecruitShowHeroWindow = class("Lua_RecruitShowHeroWindow", Lua_Window);
function Lua_RecruitShowHeroWindow:ctor()
	self:superCall("ctor");

	self.skinName = "RecruitShowHeroWindow_skin";
	self.windowName = "Lua_RecruitShowHeroWindow";
	self.isFullSizeWin = true;
	self.isFullSizeBg = true;
	self.showBlackMask = true;
end

function Lua_RecruitShowHeroWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.tipTxt:setLangValue(140305);
	self.shareObj:SetActive(false);
	self.heroObj:SetActive(false);
	self.noTweenObj:SetActive(false);
	self.quickOpenBtn:setEnable(false);
	LuaUtil.setRectSize(self.heroObj, self.width, self.height);
	LuaUtil.setRectSize(self.noTweenObj, self.width, self.height);
	
	self.leftBtn:addClickFuntion(self, self.onLeftBtnClick);
	self.rightBtn:addClickFuntion(self, self.onRightBtnClick);
	self.shareIcon:addClickFuntion(self, self.onShareIconClick);
	self.worldSp:addClickFuntion(self, self.onClickShareWorldSp); -- 世界分享icon
	self.areaSp:addClickFuntion(self, self.onClickShareAreaSp); -- 频道分享icon
	self.quickOpenBtn:addClickFuntion(self, self.onClickQuickOpenBtn); -- 快速翻卡
	self.leftIcon:addClickFuntion(self, self.onCrumbClick);
	self.rightIcon:addClickFuntion(self, self.onCrumbClick);

	self:addLuaEvent("SINGLE_HERO_WIN_HIDE", self, self.updateNextHeroCard); -- 十抽招募界面关闭时，执行下一个卡牌
	self:addLuaEvent("RECRUIT_SHOWHERO_SCENE", self, self.recruitItemClickfunc); -- item点击返回事件，展示英雄界面
	self:addLuaEvent("CLOSE_RECRUIT_SHOWHERO", self, self.hide); -- 关闭该窗口
end

function Lua_RecruitShowHeroWindow:onClickShareWorldSp()
	if not DataCenter.funcOpenData:isOpened(10228) then
		OperateAlert.showLangValue(140353);
	else
		self.shareIndex = 1;
		self:onClickBaseShareIcon();
	end
end

function Lua_RecruitShowHeroWindow:onClickShareAreaSp()
	if not DataCenter.funcOpenData:isOpened(10229) then
		OperateAlert.showLangValue(140353);	
	elseif DataCenter.roleData.league_id <= 0 then
		OperateAlert.showLangValue(140354);
	else
		self.shareIndex = 2;
		self:onClickBaseShareIcon();
	end
end

function Lua_RecruitShowHeroWindow:onClickBaseShareIcon()
	local channelStr = self.shareIndex == 1 and LanUtil.getValue(140355) or LanUtil.getValue(140356);
	local tipsData = { font_size = 28, des = LanUtil.formateStr(140357, channelStr), posY = 30,
            btnType = 1, owner = self, sureFun = self.onSendChatMsg
        };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);

	self:onShareIconClick();
end

function Lua_RecruitShowHeroWindow:onSendChatMsg()
	local channel;
	local channelStr; 
	if self.shareIndex == 1 then
		channel = Lua_ChatData.CHANNEL_WORLD; 
		channelStr = LanUtil.getValue(140355);
	else
		channel = Lua_ChatData.CHANNEL_LEAGUE;
		channelStr = LanUtil.getValue(140356);
	end
	DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_RECRUIT_LUCKY, DataCenter.recruitData.recruitShow);
	Lua_ChatUtil.sendMsg(channel, "", false, false);

	OperateAlert.show(LanUtil.formateStr(140358, channelStr));
end

function Lua_RecruitShowHeroWindow:onCrumbClick(go)
	if go.name == "leftIcon" then
		if self.leftClickEff == nil then
			self.leftClickEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_zhaomu_dianji", "ui_zhaomu_dianji", 0, 720);
			self.leftClickEff.anchorValue = 7;
		else
			self.leftClickEff:setEnable(false);
			self.leftClickEff:setEnable(true);
		end
	elseif go.name == "rightIcon" then
		if self.rightClickEff == nil then
			self.rightClickEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_zhaomu_dianji", "ui_zhaomu_dianji", 420, 720);
			self.rightClickEff.anchorValue = 7;
		else
			self.rightClickEff:setEnable(false);
			self.rightClickEff:setEnable(true);
		end
	end

	Lua_CommonUtil.removeTimer(self, self.onCrumbTipEff);

	if self.crumbTipEff ~= nil then
		self.crumbTipEff:setEnable(false);
	end
	self.tipTxt:setEnable(false);

	if self.crumbClickNum == 0 then 
		self.crumbClickTime = getTime();

		if self.crumbEff ~= nil then
			self.crumbEff:dispose();
			self.crumbEff = nil;
		end
		self.curLoopAni = nil;

		if self.tweenType == 1 then
			self:showBaseEffect(false);
		else
			self:hidetenBaseEffect();
		end
		AudioManager.instance:play("zhaomu_yaodong");
	end
	local lastTime = self.crumbClickTime;
	self.crumbClickTime = getTime();
	self.crumbClickNum = self.crumbClickNum + 1;
	if self.crumbClickNum <= DataCenter.recruitUtil:getCrumbEffLimit(self.tweenType) and self.crumbClickTime - lastTime < self.curCfg.arr_value[1] then
		self.crumbEffCfg = DataCenter.recruitUtil:getCrumbEffCfg(self.tweenType, self.crumbClickNum);

		if self.crumbEff == nil then
			self.crumbEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/" .. self.crumbEffCfg[2], self.crumbEffCfg[2], self.curCfg.posX, self.curCfg.posY);
			self.crumbEff.anchorValue = self.curCfg.anchorValue;
			self.crumbEff:setScale(self.curCfg.facScale, self.curCfg.facScale);
			self.crumbEff:addLuaSpineAniEvtFun(self, self.onCrumbEffAni);
		end

		if self.tweenType == 1 then
			self:removeSingleDrawingTimer();
			Lua_CommonUtil.delayCall(self.curCfg.arr_value[1], self, self.updateSingleStepEffect);
		else
			Lua_CommonUtil.removeTimer(self, self.updateTenRecruitStepEffect);
			Lua_CommonUtil.delayCall(self.curCfg.arr_value[1], self, self.updateTenRecruitStepEffect);
		end
	end
end

function Lua_RecruitShowHeroWindow:onCrumbEffAni()
	if self.curLoopAni == nil or self.curLoopAni ~= self.crumbEffCfg[3] then
		self.curLoopAni = self.crumbEffCfg[3];
		self.crumbEff:setSpineAniState(0, self.crumbEffCfg[3]);
	end
end

function Lua_RecruitShowHeroWindow:onCrumbTipEff()
	if self.crumbTipEff == nil then
		local config = getConfig("recruit_tween", "crumb_tip_effect");
		self.crumbTipEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/" .. config.effectName, config.effectName, config.posX, config.posY);
		self.crumbTipEff.anchorValue = config.anchorValue;
	end
	self.crumbTipEff:setEnable(true);
	self.tipTxt:setEnable(true);
end

function Lua_RecruitShowHeroWindow:hide()
	self:playUITween("recruit_movingUI", true);
	self:superCall("hide");
end

function Lua_RecruitShowHeroWindow:onScreenResize()
	self:superCall("onScreenResize");

	LuaUtil.setRectSize(self.heroObj, self.width, self.height);
	LuaUtil.setRectSize(self.noTweenObj, self.width, self.height);
end

function Lua_RecruitShowHeroWindow:showWin(param)
	self:superCall("showWin",param);
	if param == nil then
		self:hide();
		return;
	end
    
    if self.heroList == nil then
		self.heroList = {};
	end

	self.bTweenCompleted = false;
    -- 获得的英雄
    local count;
	if self.showData.itemList ~= nil then
        -- local position;
        local item;
        local obj;
        count = self.showData.itemList:getSize();
        if count == 10 then
        	self.tweenType = 10;
			self.heroObj:SetActive(false);
			self.noTweenObj:SetActive(false);
        	for i = 1, count do
        		obj = self.showData.itemList[i];
        		item = self:getItem(i);
        		item.content.name = "RecruitShowHeroItem_"..i;
        		item:setData(obj, false);

        		if DataCenter.recruitData.selectType == Lua_RecruitData.NEWHERO then
        			item:showShareEffect(false);
        		else
        			item:showPageMask(true);
        		end

        		self:updateRecruitItemOriginSetting(item, i);
        	end
        	UIUtils.setObjSiblingIndex(self.shareObj, 19);
        	self:startTenTween();
        elseif count == 1 then
			self.tweenType = 1;
			self.heroObj:SetActive(false);
			self.noTweenObj:SetActive(false);
        	obj = self.showData.itemList[count];
    		item = self:getItem(count);
    		item:setData(obj, true);
    		item:setLocation(0, -632);
    		item:showFlashCardDisplay();
			self:startSigleTween();
        end

        for i = count + 1, #self.heroList do
        	self.heroList[i]:setEnable(false);
        end
	end

	self.rightBtn.label = LanUtil.getValue(10008);
	self.leftBtn.label = count == 1 and LanUtil.getValue(140359) or LanUtil.getValue(140360);

	--道具显示
	if self.showData.costId ~= nil then
		local toolVo;
		self.costIcon:setEnable(true)
		if DataCenter.moneyData:isMoney(self.showData.costId) then
			toolVo = Lua_ToolVo.createToolVo(self.showData.costId);
			self.costIcon:setAltas(toolVo.iconAtlas, toolVo.iconSprite);
		else
			toolVo = Lua_ToolVo.createToolVo(self.showData.costId);
			self.costIcon:setAltas(toolVo.iconAtlas, toolVo.iconSprite);
			print(self.showData.costId,toolVo.iconAtlas, toolVo.iconSprite);
		end
		self.costIcon:SetDimensions(toolVo.iconWidth, toolVo.iconHeight);
	end

	--道具数量
	if self.showData.costTxt ~= nil then
		self.costLbl:setEnable(true);
		self.costLbl.text = self.showData.costTxt;
	end
	if DataCenter.recruitData.selectType ~= Lua_RecruitData.NEWHERO then
		self:showLuckyValue();
	end
end

function Lua_RecruitShowHeroWindow:getItem(index)
	local item = self.heroList[index];
	if item == nil then
		item = Lua_RecruitShowHeroItem.new(self.heroObj);
		item:setRectAnchor(1);
		self.heroList[index] = item;
	end
	item:setEnable(true);
	return item;
end

function Lua_RecruitShowHeroWindow:showLuckyValue()
	self:startTimer();
end

function Lua_RecruitShowHeroWindow:startTimer()
    if self.bTimer ~= true then
        self.bTimer = true;
        self.lastValue = 0;--DataCenter.recruitData.lastLuckValue;
        self.luckyValueTxt.text = self.lastValue;
        Lua_CommonUtil.addTimer("Lua_RecruitShowHeroWindow_updateLuckTxt", 0.01, self, self.onTimer);
    end
end

function Lua_RecruitShowHeroWindow:removeTimer()
    if self.bTimer == true then
        self.bTimer = false;
        Lua_CommonUtil.removeTimer(self, self.onTimer);
    end
end

function Lua_RecruitShowHeroWindow:onTimer()
	local txtValue = self.luckyValueTxt.text;
	local targetValue = DataCenter.recruitData.curLuckValue;
	local distance = targetValue - self.lastValue;
	local curValue = txtValue + Mathf.Floor(distance * 0.1);

	if targetValue - curValue < 6 then
		curValue = targetValue;
		-- DataCenter.recruitData.lastLuckValue = targetValue;
		self:removeTimer();
	end
	self.luckyValueTxt.text = curValue;
end

function Lua_RecruitShowHeroWindow:onLeftBtnClick()
	local bTenRecruit = self.tweenType == 10;
	if not bTenRecruit then
		Lua_MsgUtil.callFunc("CLICK_SENIORRECRUIT_ONERECRUIT");
	else
		Lua_MsgUtil.callFunc("CLICK_SENIORRECRUIT_TENRECRUIT");
	end
end

function Lua_RecruitShowHeroWindow:onRightBtnClick()
	DataCenter.heroAssemblyData:showAutoDecomposeReward(); --展示自动流放奖励
	if DataCenter.recruitData.selectType == Lua_RecruitData.NEWHERO then
		Lua_MsgUtil.callFunc("CLOSE_NEWHERO_RECRUIT_SHOW");
	end
	self:hide();
end

function Lua_RecruitShowHeroWindow:onShareIconClick()
	self.shareObj:SetActive(not self.shareObj.activeSelf);
end

-- 单抽开始  startSigleTween
function Lua_RecruitShowHeroWindow:startSigleTween()
	if DataCenter.recruitData.selectType == Lua_RecruitData.NEWHERO then
		self.tweenIndex = 6;
	else
		self.tweenIndex = 1;
	end
	
	self.tweenType = 1;
	self:playUITween("recruit_movingUI", false);
	self:updateSingleStepEffect();
end

function Lua_RecruitShowHeroWindow:updateSingleStepEffect()
	local config = getConfig("recruit_tween", "tween_Type", "arr_value");
	local tweenType = self.tweenType == 1 and config[1] or config[2];
	local tweenId = tweenType.."_"..self.tweenIndex;
	config = getConfig("recruit_tween", tweenId);
	self.curCfg = config;
	if config ~= nil then
		local skipStep = getConfig("recruit_tween", "danchou_skipStep","value");
		if self.tweenIndex <= skipStep then
			if self.tweenIndex == 2 then
				self.leftIcon:setEnable(true);
				self.rightIcon:setEnable(true);
				self.tipTxt:setEnable(false);
				self.crumbClickNum = 0;
				Lua_CommonUtil.delayCall(config.arr_value[2], self, self.onCrumbTipEff);
			end
			if not DataCenter.guideData.isGuiding then
				self.quickOpenBtn:setEnable(true);
			end
			if config.effectName ~= nil then
				self:showBaseEffect(true, config.effectName, config.posX, config.posY, config.anchorValue);
			end
		else
			self.quickOpenBtn:setEnable(false);
			self:showSingleDrawHeroColorEffect(config, skipStep);
			self:checkCrumbEnd(true);
		end

		AudioManager.instance:stop("zhaomu_yaodong");
		if config.audio ~= nil then
			AudioManager.instance:play(config.audio);
		end

		local playTime = config.playTime;
		if self.tweenIndex == 5 then -- 播放出卡品质特效
			local index = self.showData.itemList[1].color - 1;
			if index >= 4 then
				index = 4;
			end
			playTime = config.arr_value[index];
		end

		if self.crumbEff ~= nil then
			self.crumbEff:setEnable(false);
		end
		if self.crumbTipEff ~= nil then
			self.crumbTipEff:setEnable(false);
		end
		if self.leftClickEff ~= nil then
			self.leftClickEff:setEnable(false);
		end
		if self.rightClickEff ~= nil then
			self.rightClickEff:setEnable(false);
		end
		self.tipObj:SetActive(self.tweenIndex == 2);

		self:removeSingleDrawingTimer();
		self.tweenIndex = self.tweenIndex + 1;
		if playTime ~= -1 then
			Lua_CommonUtil.delayCall(playTime, self, self.updateSingleStepEffect);
		end
	else
		self:removeSingleDrawingTimer();
	end
end

function Lua_RecruitShowHeroWindow:removeSingleDrawingTimer()
	Lua_CommonUtil.removeTimer(self, self.updateSingleStepEffect);
end

function Lua_RecruitShowHeroWindow:showBaseEffect(bShow, effectName, posX, posY, anchorValue, facScale)
	if bShow then
		local url = "/effects/uiEffects/"..effectName;
		if self.uiEffect == nil then
			self.uiEffect = UICreate.createUIEffect(self.content, url, effectName, 0, 0);
		else
			self.uiEffect:setUrl(url, effectName);
		end

		local _posX = posX or 0;
		local _posY = posY or 0;
		local _anchor = anchorValue or 4;
		local _facScale = facScale or 1;
		self.uiEffect:setLocation(_posX, _posY);
		self.uiEffect.anchorValue = _anchor;
		self.uiEffect:setScale(_facScale, _facScale);
		self.uiEffect:setEnable(true);
	else
		if self.uiEffect ~= nil then
			self.uiEffect:setEnable(false);
		end
	end
end

function Lua_RecruitShowHeroWindow:showSingleDrawHeroColorEffect(config, skipStep)
	local heroVo = self.showData.itemList[1];
	if heroVo ~= nil and heroVo.color then
		local index = heroVo.color - 1;
		local completeStep = self.tweenIndex - skipStep;
		local keyStr = "danchou_quality_effect_"..index;
		local qualityEffect = getConfig("recruit_tween", keyStr, "arr_value");
		local effectName = qualityEffect[completeStep];
		local facScale = 1;
		if completeStep == 3 and heroVo.recruitFlashId ~= nil then
			effectName = config.effectName;
			facScale = config.facScale;
		end
		-- self:showBaseEffect(true, effectName, config.posX, config.posY, config.anchorValue, facScale);
		if completeStep == 3 then
			DataCenter.chatData:playNextBroadcast(1025);
			DataCenter.chatData:playNextBroadcast(1060);
			DataCenter.chatData:playNextBroadcast(1061);

			local item = self:getItem(1);
			item:showBaseEffect(true, effectName, 0, 0, 4, facScale)
			self:showBaseEffect(false);
			self.heroObj:SetActive(true);
			self.bTweenCompleted = true; -- 动画播放结束	

			AudioManager.instance:play("zhaomu_fanka");

			if DataCenter.recruitData.selectType == Lua_RecruitData.NEWHERO then
				self.luckySp:setEnable(false);
				self.luckyValueTxt:setEnable(false);
				self.shareIcon:setEnable(false);
				self.noTweenObj:SetActive(true);
			else
				local bShowHero = heroVo.color == 5 or (DataCenter.recruitData.recruitNum == 1 and DataCenter.recruitData.selectType == Lua_RecruitData.SENIOR);
				if bShowHero then
					local time = getConfig("recruit_tween", "delay_show_hero_window", "arr_value")[1];
					Lua_CommonUtil.delayCall(time, self, self.showScene, heroVo.id);
				else
					self.noTweenObj:SetActive(true);
				end
			end			
		else
			self:showBaseEffect(true, effectName, config.posX, config.posY, config.anchorValue, facScale);
		end
	end
end

function Lua_RecruitShowHeroWindow:onClickQuickOpenBtn()
	if self.tweenType == 1 then
		local skipStep = getConfig("recruit_tween", "danchou_skipStep", "value");
		self:removeSingleDrawingTimer();
		self.tweenIndex = skipStep and skipStep + 1 or self.tweenIndex;
		self:updateSingleStepEffect();
	elseif self.tweenType == 10 then
		local skipStep = getConfig("recruit_tween", "duochou_skipStep", "value");
		self.tweenIndex = skipStep and skipStep + 1 or self.tweenIndex;

		Lua_CommonUtil.removeTimer(self, self.hideBgEffect);
		Lua_CommonUtil.removeTimer(self, self.hidetenBaseEffect);
		Lua_CommonUtil.removeTimer(self, self.updateTenRecruitStepEffect);
		self:hideBgEffect();
		self:hidetenBaseEffect();
		self:updatePosWhenQuickOpen();
		self.showHeroNum = nil;
		self.heroObj:SetActive(true);
		self:showItemListEffect(false, nil, nil, true);
		self:updateTenRecruitStepEffect();
	end
	Lua_CommonUtil.removeTimer(self, self.onCrumbTipEff);
end

-- 一键翻卡-十连卡牌位置更新
function Lua_RecruitShowHeroWindow:updatePosWhenQuickOpen()
	if self.tweenType == 10 then
		self.showData.itemList:getSize()
		local item;
		local keyStr;
		local config;
		for i = 1, 10 do
			keyStr = "RecruitShowHeroItem_".. i;
			config = getConfig("recruit_tween", keyStr, "arr_value");
			local param = config and config[5];
			item = self.heroList[i];--self.showData.itemList[i];
			if item ~= nil then
				item:setLocation(param[1], param[2], param[3]);
				item:setRot(param[4], param[5], param[6]);
				item:setScale(param[7], param[8], param[9]);
			end
		end
	end
end

function Lua_RecruitShowHeroWindow:playUITween(type, back)
	if not back then
		Lua_RecruitTweenState.playAllTweenByType(type, false);
	else
		Lua_RecruitTweenState.playAllTweenByType(type, true);
	end
end

function Lua_RecruitShowHeroWindow:recruitItemClickfunc(heroId)
	if self.bTweenCompleted then
		self:showScene(heroId);
	end
end

function Lua_RecruitShowHeroWindow:showScene(heroId)
	local heroVo ;--= Lua_HeroVo.new(heroId);
	local replaceCfg = DataCenter.heroUtil:getHeroReplaceStarCfg(heroId);
	if replaceCfg ~= nil then
        heroVo = Lua_ToolVo.createToolVo(replaceCfg.hero_id);
        heroVo.quality = replaceCfg.quality;
        heroVo.quality_star = replaceCfg.quality_star;
    else
    	heroVo = Lua_HeroVo.new(heroId);
    end

	DataCenter.preLoadData:preShowModelScene("Lua_RecruitShowSingleHeroWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onShowModel, heroVo, heroVo);
end

function Lua_RecruitShowHeroWindow:onShowModel(param, modelScenePanel)
    param.modelScenePanel = modelScenePanel;
    Lua_WindowUtil.openWin("Lua_RecruitShowSingleHeroWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_RecruitShowHeroWindow:removeShowModel()
    DataCenter.preLoadData:removeBySign("Lua_RecruitShowSingleHeroWindow", self, self.onShowModel);
end

--十抽开始  startTenTween
function Lua_RecruitShowHeroWindow:startTenTween()
	if DataCenter.recruitData.selectType == Lua_RecruitData.NEWHERO then
		self.tweenIndex = 6;
	else
		self.tweenIndex = 1;
	end
	self.tweenType = 10;
	self.showHeroNum = nil;
	self:playUITween("recruit_movingUI", false);
	self:updateTenRecruitStepEffect();
end

function Lua_RecruitShowHeroWindow:updateOpenBtnState()
	local keyStr = self.tweenType == 1 and "danchou_skipStep" or "duochou_skipStep";
	local skipStep = getConfig("recruit_tween", keyStr,"value");
	self.quickOpenBtn:setEnable(self.tweenIndex <= skipStep and not DataCenter.guideData.isGuiding);
end

function Lua_RecruitShowHeroWindow:updateTenRecruitStepEffect()
	local config = getConfig("recruit_tween", "tween_Type", "arr_value");
	local tweenType = self.tweenType == 1 and config[1] or config[2];
	local tweenId = tweenType.."_"..self.tweenIndex;
	config = getConfig("recruit_tween", tweenId);
	self.curCfg = config;
	if config ~= nil then
		self:updateOpenBtnState();
		local playTime = config.playTime;
		-- if config.effectType == -1 then -- 背景
		-- 	self:showBgEffect(true, config.effectName, config.posX, config.posY, config.anchorValue);
		-- 	Lua_CommonUtil.delayCall(playTime, self, self.hideBgEffect);
		-- 	playTime = 0.01;
		-- elseif config.effectType == 1 then -- 正常播放特效
		-- 	self:showTenBaseEffect(true, config.effectName, config.posX, config.posY, config.anchorValue);
		-- 	Lua_CommonUtil.removeTimer(self, self.hidetenBaseEffect);
		-- 	Lua_CommonUtil.delayCall(playTime, self, self.hidetenBaseEffect);
		-- 	playTime = 0.01;
		-- elseif config.effectType == 2 then -- 使用TweenUtil.getInstance():addTween进行操作
		-- 	self.heroObj:SetActive(true);
		-- 	self:playUITween("RecruitShowHeroItem", false);
		-- elseif config.effectType == 3 then -- 每个item播放特效
		-- 	self:showItemListEffect(true, config.effectName, playTime);
		-- elseif config.effectType == 4 then -- 每个item依次展示
		-- 	self:showItemDetail();
		-- end

		self:showAddEffect(false);

		if self.tweenIndex == 2 then -- 捏碎动画处理
			self.leftIcon:setEnable(true);
			self.rightIcon:setEnable(true);
			self.tipTxt:setEnable(false);
			self.crumbClickNum = 0;
			Lua_CommonUtil.delayCall(config.arr_value[2], self, self.onCrumbTipEff);
		elseif self.tweenIndex == 4 then -- 袋口品质色
			self:showTenBaseEffect(true, config.arr_value[self.showData.maxQuality], config.posX, config.posY, config.anchorValue);
		elseif self.tweenIndex == 6 then -- 每个item依次展示
			DataCenter.chatData:playNextBroadcast(1025);
			DataCenter.chatData:playNextBroadcast(1060);
			DataCenter.chatData:playNextBroadcast(1061);
			
			self:hideBgEffect();
			self:hidetenBaseEffect();
			self:updatePosWhenQuickOpen();
			-- self.showHeroNum = nil;
			self.heroObj:SetActive(true);
			-- self:showItemListEffect(false, nil, nil, true);
			self:showItemDetail();

			if DataCenter.recruitData.selectType == Lua_RecruitData.NEWHERO then
				self.luckySp:setEnable(false);
				self.luckyValueTxt:setEnable(false);
				self.shareIcon:setEnable(false);
				self.bTweenCompleted = true; -- 动画播放结束
				self.noTweenObj:SetActive(true);
			end
			
			self:checkCrumbEnd(true);
		else
			self:showTenBaseEffect(true, config.effectName, config.posX, config.posY, config.anchorValue);
		end

		AudioManager.instance:stop("zhaomu_yaodong");
		if config.audio ~= nil then
			AudioManager.instance:play(config.audio);
		end

		if self.crumbEff ~= nil then
			self.crumbEff:setEnable(false);
		end
		if self.crumbTipEff ~= nil then
			self.crumbTipEff:setEnable(false);
		end
		if self.leftClickEff ~= nil then
			self.leftClickEff:setEnable(false);
		end
		if self.rightClickEff ~= nil then
			self.rightClickEff:setEnable(false);
		end
		self.tipObj:SetActive(self.tweenIndex == 2);

		self.tweenIndex = self.tweenIndex + 1;
		Lua_CommonUtil.removeTimer(self, self.updateTenRecruitStepEffect);
		if playTime ~= -1 then
			Lua_CommonUtil.delayCall(playTime, self, self.updateTenRecruitStepEffect);
		end
	-- else
	-- 	self:removeSingleDrawingTimer();
	end
end

function Lua_RecruitShowHeroWindow:showTenBaseEffect(bShow, effectName, posX, posY, anchorValue)
	if bShow then
		local url = "/effects/uiEffects/"..effectName;
		if self.ten_uiEffect == nil then
			self.ten_uiEffect = UICreate.createUIEffect(self.content, url, effectName, 0, 0);
		else
			self.ten_uiEffect:setUrl(url, effectName);
		end

		local _posX = posX or 0;
		local _posY = posY or 0;
		local anchor = anchorValue or 4;
		self.ten_uiEffect:setLocation(_posX, _posY);
		self.ten_uiEffect.anchorValue = anchor;
		self.ten_uiEffect:setEnable(true);
	else
		if self.ten_uiEffect ~= nil then
			self.ten_uiEffect:setEnable(false);
		end
	end
end

function Lua_RecruitShowHeroWindow:showAddEffect(bShow, effectName, posX, posY, anchorValue)
	if bShow then
		local url = "/effects/uiEffects/"..effectName;
		if self.addEffect == nil then
			self.addEffect = UICreate.createUIEffect(self.content, url, effectName, 0, 0);
		else
			self.addEffect:setUrl(url, effectName);
		end

		local _posX = posX or 0;
		local _posY = posY or 0;
		local anchor = anchorValue or 4;
		self.addEffect:setLocation(_posX, _posY);
		self.addEffect.anchorValue = anchor;
		self.addEffect:setEnable(true);
	else
		if self.addEffect ~= nil then
			self.addEffect:setEnable(false);
		end
	end
end

function Lua_RecruitShowHeroWindow:hidetenBaseEffect()
	if self.ten_uiEffect ~= nil then
		self.ten_uiEffect:setEnable(false);
	end
end

-- 背景特效
function Lua_RecruitShowHeroWindow:showBgEffect(bShow, effectName, posX, posY, anchorValue)
	if bShow then
		local url = "/effects/uiEffects/"..effectName;
		if self.bgEffect == nil then
			self.bgEffect = UICreate.createUIEffect(self.content, url, effectName, 0, 0);
		else
			self.bgEffect:setUrl(url, effectName);
		end
		self.bgEffect.siblingIndex = 0;

		local _posX = posX or 0;
		local _posY = posY or 0;
		local anchor = anchorValue or 4;
		self.bgEffect:setLocation(_posX, _posY);
		self.bgEffect.anchorValue = anchor;
		self.bgEffect:setEnable(true);
	else
		self.bgEffect:setEnable(false);
	end
end

function Lua_RecruitShowHeroWindow:hideBgEffect()
	if self.bgEffect ~= nil then
		self.bgEffect:setEnable(false);
	end
end

function Lua_RecruitShowHeroWindow:showItemListEffect(bShow, effectName, playTime, bDelDelayCall)
	if self.tweenType == 10 then
		local item;
		for i = 1, 10 do
			item = self.heroList[i];
			item:showShakeEffect(bShow, effectName, playTime, bDelDelayCall);
		end
	end
end

function Lua_RecruitShowHeroWindow:updateRecruitItemOriginSetting(obj, index)
	if obj ~= nil and index ~= nil then
		local str = "RecruitShowHeroItem_"..index;
		local config = getConfig("recruit_tween", str, "arr_value")[4];
		obj:setLocation(config[1], config[2], config[3]);
		obj:setRot(config[4], config[5], config[6]);
		obj:setScale(config[7], config[8], config[9]);

		Lua_RecruitTweenState.addTweenObj(obj.content);
	end
end

function Lua_RecruitShowHeroWindow:removeUITween()
	if self.tweenType == 10 then
		local item;
		for i = 1, 10 do
			item = self.heroList[i];
			Lua_RecruitTweenState.removeTween(item.content, "RecruitShowHeroItem");
		end
	end
end

function Lua_RecruitShowHeroWindow:updateNextHeroCard()
	if self.tweenType == 10 then
		LogManager.showLog("十连抽英雄展示窗口已关闭");
		self:showItemDetail();
	elseif self.tweenType == 1 then
		self.noTweenObj:SetActive(true);
	end
end

function Lua_RecruitShowHeroWindow:showItemDetail()
	if DataCenter.recruitData.selectType == Lua_RecruitData.NEWHERO then
		return;
	end

	if self.tweenType == 10 then
		if self.showHeroNum == nil then
			self.showHeroNum = 1;
		end

		if self.showData == nil then
			return;
		end
		local heroVo = self.showData.itemList[self.showHeroNum];
		local item = self.heroList[self.showHeroNum];
		self:testShowInfo(self.showHeroNum, heroVo);
		if heroVo ~= nil and item ~= nil then
			local heroQuality = heroVo.color;
			item:showIdleDisplay();

			AudioManager.instance:play("zhaomu_fanka");

			local isShowHeroScence = heroQuality == 5;
			if isShowHeroScence then
				Lua_CommonUtil.removeTimer(self, self.showScene);

				local time = getConfig("recruit_tween", "delay_show_hero_window", "arr_value")[2];
				Lua_CommonUtil.delayCall(time, self, self.showScene, heroVo.id);
			else
				Lua_CommonUtil.removeTimer(self, self.showItemDetail);
				Lua_CommonUtil.delayCall(0.3, self, self.showItemDetail);
			end
			self.showHeroNum = self.showHeroNum + 1;
		else
			self.bTweenCompleted = true; -- 动画播放结束
			self.noTweenObj:SetActive(true);

			self:checkWinGuide(); -- 引导数据
		end
	end
end

function Lua_RecruitShowHeroWindow:testShowInfo(num, heroVo)
	if num <= 10 and heroVo ~= nil then
		LogManager.showLog("第"..num.."个英雄显示卡牌,英雄id为"..heroVo.id.."英雄品质为"..heroVo.color);
	end
end

function Lua_RecruitShowHeroWindow:checkCrumbEnd(value)
	self.bCrumbEnd = value;
	if self.bCrumbEnd then
		self:checkWinGuide(); -- 引导数据
	end
end

-- 检测引导数据
function Lua_RecruitShowHeroWindow:checkWinGuide()
    self:superCall("checkWinGuide");
end

-- 引导同步
function Lua_RecruitShowHeroWindow:updateGuide(guideId, info)
    if info == nil then
        return;
    end
    local operateVal = info.operateVal; -- 操作行为参数
    if operateVal == nil then
        return;
    end
    if operateVal == 1 then -- 动画结束
    	if self.bTweenCompleted then
    		DataCenter.guideCommonData.guideClickObjPath = "content/noTweenObj/rightBtn";
    		DataCenter.guideCommonData.guideSceneId = nil; -- 场景
            Lua_MsgUtil.callFunc("Guide_WinSync_Complete", guideId);
    	end
    elseif operateVal == 2 then -- 捏干脆面
    	if self.bCrumbEnd then -- 捏干脆面结束
    		DataCenter.guideCommonData.winGuideResult = 1;
    		Lua_MsgUtil.callFunc("Guide_WinSync_Complete", guideId);
    		self.quickOpenBtn:setMouseEnable(true);
        else
        	self.quickOpenBtn:setMouseEnable(false);
        	DataCenter.guideCommonData.hideGuideEffect = true;
        	Lua_MsgUtil.callFunc("Guide_WinSync_Complete", guideId);
    	end
    end
end

function Lua_RecruitShowHeroWindow:dispose()
	self:removeShowModel();
	self:removeUITween();

	AudioManager.instance:stop("zhaomu_yaodong");

	if self.heroList ~= nil then
		for i = 1, #self.heroList do
			self.heroList[i]:dispose()
			self.heroList[i] = nil;
		end
		self.heroList = nil;
	end
	if self.ten_uiEffect ~= nil then
		self.ten_uiEffect:dispose();
		self.ten_uiEffect = nil;
	end
	if self.uiEffect ~= nil then
		self.uiEffect:dispose();
		self.uiEffect = nil;
	end
	if self.crumbEff ~= nil then
		self.crumbEff:dispose();
		self.crumbEff = nil;
	end
	if self.crumbTipEff ~= nil then
		self.crumbTipEff:dispose();
		self.crumbTipEff = nil;
	end
	if self.leftClickEff ~= nil then
		self.leftClickEff:dispose();
		self.leftClickEff = nil;
	end
	if self.rightClickEff ~= nil then
		self.rightClickEff:dispose();
		self.rightClickEff = nil;
	end

	self:removeTimer();
	self:removeSingleDrawingTimer();
	Lua_CommonUtil.removeTimer(self, self.showScene);
	Lua_CommonUtil.removeTimer(self, self.hideBgEffect);
	Lua_CommonUtil.removeTimer(self, self.updateTenRecruitStepEffect);
	Lua_CommonUtil.removeTimer(self, self.hidetenBaseEffect);
	Lua_CommonUtil.removeTimer(self, self.onCrumbTipEff);
	DataCenter.recruitData.onBtnControl = false;
	self.showData = nil;
	self:superCall("dispose");
end


