-- 欧气排行榜
Lua_RecruitShowLuckyRankWindow = class("Lua_RecruitShowLuckyRankWindow", Lua_Window);
function Lua_RecruitShowLuckyRankWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_RecruitShowLuckyRankWindow";
	self.skinName = "RecruitShowLuckyRankWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showClose = true;

	self.setImgPath = "/images/common/xui_common_window_001.png";
    self:addPreLoadRes(self.setImgPath, Lua_LoadFileType.IMG);
end

function Lua_RecruitShowLuckyRankWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:createTabList();
	-- 小卖部排行榜top3动画idlist
	self.topRankList = {};
	self.tweenIdTab = DataCenter.recruitUtil.recruitRankTweenList;
	-- self.topRankList = {};
	self.rankList = Lua_DragList.new(self.content, 630, 339, Lua_AxisDefine.Vertical);
	self.rankList:setListCell(Lua_RecruitShowLuckyRankItem, 630, 126, 1);
    self.rankList:setLocation(0, -109, 0);
    self.rankList.tweenId = DataCenter.recruitUtil.recruitRankTweenId;

    self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setLocation(-126, -357, 0);
	self.avatarItem:setAvatarClick(self, self.onAvatarClick);
	self.avatarItem:setScale(0.7, 0.7);
	self.myRankShareSp:addClickFuntion(self, self.onClickMyRankShareSp);


	self.tipSp:addClickFuntion(self, self.onClickTipSp);
	self:addLuaEvent("UPDATE_RECRUIT_LUCKYRANK", self, self.updatePanelInfo);
end

function Lua_RecruitShowLuckyRankWindow:createTabList()
	self.tabInfo = Array();
    self.tabInfo:add({ tabIndex = 1, textStr = LanUtil.getValue(140361)});
    self.tabInfo:add({ tabIndex = 2, textStr = LanUtil.getValue(140362)});

    self.tabBtnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    -- self.tabBtnList:setRectAnchor(7);
    self.tabBtnList:setLocation(3, -474, 0);
    self.tabBtnList.pivot = -1;
    self.tabBtnList:setButtonBg("common_altas_4", "xui_common_tab_005", 440, 65)
    self.tabBtnList:setButtonStyle("common_altas_4", "xui_common_tab_004", "xui_common_tab_004", 220, 65, 0.01, 1);
    self.tabBtnList:setButtonText(0, 0, "695d58", "8f5123", 30, 30, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
    self.tabBtnList:setButtonItem(220, 65);
    self.tabBtnList:setClickCallBack(self, self.onTabBtnClick);
    self.tabBtnList:setData(self.tabInfo);
    self.tabBtnList:setSelected(1);
end

function Lua_RecruitShowLuckyRankWindow:onTabBtnClick(index)
	if self.selectedIndex == index then
		return;
	end

	self.selectedIndex = index;
	Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sRequireLuckyRankInfo(self.selectedIndex);
end

function Lua_RecruitShowLuckyRankWindow:onClickTipSp()
	local tipsData = { des = LanUtil.getValue(140363), posX = -154, posY = -375 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_RecruitShowLuckyRankWindow:onAvatarClick()
	OperateAlert.showLangValue(140364);
end

function Lua_RecruitShowLuckyRankWindow:onClickMyRankShareSp()
	local rankInfo = DataCenter.recruitData:getRankInfoById(nil, true);
	if rankInfo.recruitShow.luck_num == 0 then
		local str = DataCenter.recruitData.curWeekType and 140365 or 140366;
		OperateAlert.showLangValue(str);
	else
		Lua_WindowUtil.openWin("Lua_RecruitShareHeroWindow", Lua_WinParam.ACTION_OPEN, rankInfo.recruitShow);
	end
end

function Lua_RecruitShowLuckyRankWindow:updatePanelInfo(isWeekRank)
	local vo;
	local obj;
	local rankList = DataCenter.recruitData.topRankIdList;
	for i = 1, #rankList do
		obj = rankList[i];
		vo = self.topRankList[i];
		if vo == nil then
			vo = Lua_RecruitShowLuckyRankTopItem.new(self.content);
			vo.content.name = "Lua_RecruitShowLuckyRankTopItem"..i;
			-- vo:setRectAnchor(1);
			self.topRankList[i] = vo;
		end
		vo:setData(i, obj);
	end
	self:playRankTween();

	rankList = DataCenter.recruitData.otherRankIdList;
	self.rankList.showTween = true;
	self.rankList:setArrayData(rankList);
	self.rankList:moveToIndex(1, true);

	local rankInfo = DataCenter.recruitData:getRankInfoById(nil, true);
	if rankInfo.rankId == 0 then
		self.myRankNumTxt:setLangValue(140367);
		self.myRankNumTxt.fontName = Lua_MyUISettings.huakangFontName;
		self.myRankNumTxt.fontSize = 26;
		self.myRankNumTxt.effectColorStr = Lua_ColorDefine.transColorStr("39312f");
	else
		self.myRankNumTxt.text = rankInfo.rankId;
		self.myRankNumTxt.fontName = Lua_MyUISettings.fangzhengFontName;
		self.myRankNumTxt.fontSize = 50;
		self.myRankNumTxt.effectColorStr = Lua_ColorDefine.transColorStr("3e3b44");
	end
	self.myNameTxt.text = rankInfo.playerShow.name;
	self.myRankLuckTxt.text = rankInfo.recruitShow.luck_num;
	self.avatarItem:setRoleDressUp(rankInfo.playerShow.dress_info, true);
	self.avatarItem:setRoleLevel2(rankInfo.playerShow.level);
end

function Lua_RecruitShowLuckyRankWindow:playRankTween()
	if self.topRankList ~= nil then
		local item; 
		local tweenId = 3050;
		for i = 1, #self.topRankList do
			tweenId = self.tweenIdTab[i] or tweenId;
			self:removeTweenByIndex(i);
			item = self.topRankList[i];
			DataCenter.winTweenManager:playWinTween(tweenId, item.content.transform);
		end
	end
end

function Lua_RecruitShowLuckyRankWindow:removeTweenByIndex(index)
	if self.topRankList ~= nil and self.topRankList[index] ~= nil then
		local item = self.topRankList[index];
		TweenUtil.getInstance():stop(item.content.transform);
	end
end

function Lua_RecruitShowLuckyRankWindow:removeAllTween()
	if self.topRankList ~= nil then
		for i = 1, #self.topRankList do
			self:removeTweenByIndex(i);
		end
	end
end

function Lua_RecruitShowLuckyRankWindow:resetRankInfo()
	if self.topRankList ~= nil then
		for i = 1, #self.topRankList do
			self.topRankList[i]:dispose();
			self.topRankList[i] = nil;
		end
		self.topRankList = nil;
	end
end

function Lua_RecruitShowLuckyRankWindow:dispose()
	self:removeAllTween();
	if self.tabInfo ~= nil then
		self.tabInfo:dispose();
		self.tabInfo:clear();
		self.tabInfo = nil;
	end
	if self.tabBtnList ~= nil then
		self.tabBtnList:dispose();
		self.tabBtnList = nil;
	end
	if self.rankList ~= nil then
		self.rankList:dispose();
		self.rankList = nil;
	end
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end

	self:resetRankInfo();
	self:superCall("dispose");
end



























--------------------------排行榜top3Vo----------------------
Lua_RecruitShowLuckyRankTopItem = class("Lua_RecruitShowLuckyRankTopItem", Lua_DisplayObject);
function Lua_RecruitShowLuckyRankTopItem:ctor(p)
    self:superCall("ctor", p, "RecruitShowLuckyRankTopItem_skin");
end

function Lua_RecruitShowLuckyRankTopItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setLocation(0, 0, 0);
	self.avatarItem:setAvatarClick(self, self.onAvatarClick);

	self.checkSp:addClickFuntion(self, self.onClickSheckSp);
end

function Lua_RecruitShowLuckyRankTopItem:setData(rankId, data)
-- --位置后续更改
	self:setPosAndColor(rankId);
	self.data = data;
	if data == -1 then
		self.nameText:setLangValue(140368);
		self.luckyValueTxt.text = "";
		self.checkSp:setEnable(false);
		self.avatarItem:setEnable(false);
	else
		local rankInfo = DataCenter.recruitData:getRankInfoById(data);
		self.playerId = rankInfo.playerShow.id;
		self.server_flag = rankInfo.playerShow.server_flag;
		self.nameText.text = rankInfo.playerShow.name;
		self.luckyValueTxt.text = rankInfo.recruitShow.luck_num;

		self.checkSp:setEnable(true);

		self.avatarItem:setEnable(true)
		self.avatarItem:setRoleId(rankInfo.playerShow.id)
		self.avatarItem:setRoleDressUp(rankInfo.playerShow.dress_info, true)
		self.avatarItem:setRoleLevel2(rankInfo.playerShow.level)
	end
end

function Lua_RecruitShowLuckyRankTopItem:onClickSheckSp()
	if self.data ~= nil and self.data ~= -1 then
		local rankInfo = DataCenter.recruitData:getRankInfoById(self.data);
		Lua_WindowUtil.openWin("Lua_RecruitShareHeroWindow", Lua_WinParam.ACTION_OPEN, rankInfo.recruitShow);
	end
end

function Lua_RecruitShowLuckyRankTopItem:setPosAndColor(rankId)
-- 具体位置后续更改
	if rankId == 1 then
		self:setLocation(0, 277);
		self.avatarItem:setScale(0.82, 0.82, 0.82);
		self.avatarItem:setLocation(-1, 110, 0);

		self.rankNumTxt.fontSize = 30;
		self.rankNumTxt.colorStr = Lua_ColorDefine.transColorStr("FCF6AF");
		self.nameText.fontSize = 30
		self.nameText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")
		self.luckyValueTxt.colorStr = Lua_ColorDefine.transColor("FFFFFF")
		self.luckyValueTxt.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")

	elseif rankId == 2 then
		self:setLocation(-210, 276);
		self.avatarItem:setScale(0.7, 0.7, 0.7)
		self.avatarItem:setLocation(0, 99, 0);

		self.rankNumTxt.fontSize = 26;
		self.rankNumTxt.colorStr = Lua_ColorDefine.transColorStr("FFFFFF");
		self.nameText.fontSize = 26;
		self.nameText.effectColorStr = Lua_ColorDefine.transColorStr("606A93");
		self.luckyValueTxt.colorStr = Lua_ColorDefine.transColor("FFFFFF");
		self.luckyValueTxt.effectColorStr = Lua_ColorDefine.transColorStr("606A93");
	else
		self:setLocation(215, 277);
		self.avatarItem:setScale(0.7, 0.7, 0.7)
		self.avatarItem:setLocation(0, 97, 0);

		self.rankNumTxt.fontSize = 26;
		self.rankNumTxt.colorStr = Lua_ColorDefine.transColorStr("FFFFFF");
		self.nameText.fontSize = 26;
		self.nameText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A");
		self.luckyValueTxt.colorStr = Lua_ColorDefine.transColor("FFFFFF");
		self.luckyValueTxt.effectColorStr = Lua_ColorDefine.transColorStr("876A2A");
	end

	self.bg:setAltas("rank_altas", "xui_phb_bg_"..(rankId + 1))
	self.rankNumTxt.text = LanUtil.formateStr(140369, convert_arab_to_chinese(rankId));
end

function Lua_RecruitShowLuckyRankTopItem:onAvatarClick()
	if self.playerId == nil then
		return;
	end

	if DataCenter.roleData.roleId == tonumber(self.playerId) then
		OperateAlert.showLangValue(140364);
	else
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self.playerId, self.server_flag);
	end
end

function Lua_RecruitShowLuckyRankTopItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end

	self:superCall("dispose");
end





















--------------------------排行榜非top3Vo----------------------
Lua_RecruitShowLuckyRankItem = class("Lua_RecruitShowLuckyRankItem", Lua_ListCell);
function Lua_RecruitShowLuckyRankItem:ctor(p)
    self:superCall("ctor", p, "RecruitShowLuckyRankItem_skin");
end

function Lua_RecruitShowLuckyRankItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setLocation(-125, 2, 0);
	self.avatarItem:setScale(0.7, 0.7);
	self.avatarItem:setAvatarClick(self, self.onAvatarClick);

	self.checkSp:addClickFuntion(self, self.onClickSheckSp);
end

function Lua_RecruitShowLuckyRankItem:setData(data)
	self.data = data;
	local rankInfo = DataCenter.recruitData:getRankInfoById(data);
	self.playerId = rankInfo.playerShow.id;
	self.server_flag = rankInfo.playerShow.server_flag;
	self.nameTxt.text = rankInfo.playerShow.name;
	self.luckyValue = rankInfo.recruitShow.luck_num;
	self.luckyValueTxt.text = self.luckyValue;
	self.rankNumTxt.text = rankInfo.rankId;
	self.avatarItem:setRoleDressUp(rankInfo.playerShow.dress_info, true);
	self.avatarItem:setRoleLevel2(rankInfo.playerShow.level);
end

function Lua_RecruitShowLuckyRankItem:onAvatarClick()
	if self.playerId == nil then
		return;
	end

	if DataCenter.roleData.roleId == tonumber(self.playerId) then
		OperateAlert.showLangValue(140364);
	else
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self.playerId, self.server_flag);
	end
end

function Lua_RecruitShowLuckyRankItem:onClickSheckSp()
	if self.luckyValue == 0 then
		local str = DataCenter.recruitData.curWeekType and 140365 or 140366;
		OperateAlert.show(str);
	else
		local rankInfo = DataCenter.recruitData:getRankInfoById(self.data);
		Lua_WindowUtil.openWin("Lua_RecruitShareHeroWindow", Lua_WinParam.ACTION_OPEN, rankInfo.recruitShow);
	end
end

function Lua_RecruitShowLuckyRankItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	self:superCall("dispose");
end