-- 招募显示英雄界面
checkRequire("Lua_HeroSkillItem"); --英雄技能 Item
Lua_RecruitShowSingleHeroWindow = class("Lua_RecruitShowSingleHeroWindow", Lua_Window);
function Lua_RecruitShowSingleHeroWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_RecruitShowSingleHeroWindow";
    self.skinName = "RecruitShowSingleHeroWindow_skin";
	self.isFullSizeWin = true;
	self.isSingleShowWin = true;
	self.isFullSizeBg = true;
	self.showBlackMask = true;
	self.blackAlpha = 0.1;
end

function Lua_RecruitShowSingleHeroWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.type_icon:addClickFuntion(self, self.onCompBtnClick);--阵容克制描述
	self.quality_icon:addClickFuntion(self, self.onQualityBtnClick);--质量描述
end

function Lua_RecruitShowSingleHeroWindow:showWin(param)
	self:superCall("showWin", param);

	if param.modelScenePanel then
		if self.modelScenePanel ~= nil and self.modelScenePanel ~= param.modelScenePanel then
			self.modelScenePanel:dispose();
			self.modelScenePanel = nil;
		end
		self.modelScenePanel = param.modelScenePanel
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
		param.modelScenePanel = nil
	end

	if param.trialTime ~= nil then
		self:showModel(param.heroVo);
		self:showHeroInfo(param.heroVo);
		self.time = param.trialTime + 1;
		self:onTrialTimer();
	elseif param.heroArr == nil then
		self:showModel(param);
		self:showHeroInfo(param);
	else
		self:showModel(param.heroVo);
		self:showHeroInfo(param.heroVo);
	end

	Lua_CommonUtil.delayCall(0.5, self, self.onDelay)
end

function Lua_RecruitShowSingleHeroWindow:onDelay()
    self.isClickClose = true;
    self:createCloseTips(0, 146, 0);
    self.closeText.anchorValue = 7;
end

function Lua_RecruitShowSingleHeroWindow:onMaskClick(go)
	if self.showData == nil or self.showData.heroArr == nil then
		self:superCall("onMaskClick", go);
		return;
	end

	local heroId = self.showData.heroArr:shift();
	if heroId == nil then
		self:superCall("onMaskClick", go);
		return;
	end

	self.data = Lua_HeroVo.new(heroId);
	self:showModel(self.data);
end

function Lua_RecruitShowSingleHeroWindow:showHeroInfo(vo)
	self.title.text = vo.title;
	self.name.text = vo.name;
	self.type_icon:setAltas("common_altas_3", "xui_common_attribute_"..29 + vo.campType);
	-- self.quality_icon:setAltas("hero_develop_altas", "xui_hb_attribute_" .. vo.quality);
	self.quality_icon:setAltas("common_altas_4", "xui_common_attribute_"..35+vo.quality);
	self.carrerTxt.text = vo.career_des;
	self:showStarsItem(vo)
	self:showSkills(vo);
end

-- 显示星
function Lua_RecruitShowSingleHeroWindow:showStarsItem(data)
	if data ~= nil and data.quality_star > 0 then
        if self.starInfo == nil then
            self.starInfo = Array();
        end
        local spr = "xui_common_label_15";
        local spr_bg = "xui_common_label_32";
        if data.quality >= 5 then
            spr = "xui_common_label_34";
            spr_bg = "xui_common_label_33";
        end

        local starWidth = 44;
        for i = 1, 5 do
            local item = self.starInfo[i];
            if item == nil then
                item = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
                item:setAnchorMax(0.5,1);
                item:setAnchorMin(0.5,1);
                self.starInfo:add(item);
            end

            if i <= data.quality_star then
                item:setAltas("common_altas_4",spr);
            else
                item:setAltas("common_altas_4",spr_bg);
            end
            item:resetSize();
            item:setEnable(true);
            item:setLocation(-1 * starWidth * 5 / 2 + starWidth * (i-1) + starWidth / 2-10, -103, 0);
        end
    else
        if self.starInfo ~= nil then
            local len = self.starInfo:getSize();
            for i = 1, len do
                self.starInfo[i]:setEnable(false);
            end
        end
    end
end

function Lua_RecruitShowSingleHeroWindow:onTrialTimer()
    self.time = self.time - 1;
    if self.time < 0 then
        self.time = 0;
    end
    self.timeTxt.text = Lua_TimeTransform.transSeconds9(self.time);

    if self.time > 0 then
        if not self.isTimer then
            self.isTimer = true;
            self:addTimer("onTrialTimer", 1, self, self.onTrialTimer);
        end
    else
        if self.isTimer then
            self.isTimer = false;
            self:removeTimer(self, self.onTrialTimer);
        end
    end
end

--限时时间
function Lua_RecruitShowSingleHeroWindow.Get:timeTxt()
    if self.des_txt == nil then
    	self.des_txt = UICreate.createLabel(self.content, LanUtil.getValue(760210), 0, -160, 100, 40, 26);
    	self.des_txt.anchorValue = 1;
    	self.des_txt.alignmentValue = 4;
    	self.des_txt.horizontalOverflowValue = 1;
    	self.des_txt.pivot = UIUtils.Pivot.Center;
    	self.des_txt.fontName = Lua_MyUISettings.huakangFontName;
        self.des_txt.effectStyle = 2;
        self.des_txt.effectColorStr = Lua_ColorDefine.transColor("000000");

        self.time_txt = UICreate.createLabel(self.content, nil, 0, -195, 100, 40, 26);
        self.time_txt.anchorValue = 1;
        self.time_txt.alignmentValue = 4;
        self.time_txt.horizontalOverflowValue = 1;
        self.time_txt.pivot = UIUtils.Pivot.Center;
        self.time_txt.fontName = Lua_MyUISettings.huakangFontName;
        self.time_txt.effectStyle = 2;
        self.time_txt.colorStr = Lua_ColorDefine.transColor("72e383");
        self.time_txt.effectColorStr = Lua_ColorDefine.transColor("000000");
    end
    return self.time_txt;
end

function Lua_RecruitShowSingleHeroWindow:showSkills(hvo)
    local info = hvo.heroSkillInfo;
    local bConnect = hvo.connectId > 0;
	if info ~= nil then
        if self.skillArr == nil then
            self.skillArr = Array();
        end
        local len = self.skillArr:getSize();
        for i = 1, len do
            self.skillArr[i]:setEnable(false);
        end
        local skilWidth = bConnect and 130 or 170;
        local offectX = bConnect and 73 or 0;
        for i=1,#info do
            local item = nil;
            if self.skillArr[i] ~= nil then
                item = self.skillArr[i];
            else
                item = Lua_HeroSkillItem.new(self.content);
                item:setRectAnchor(7);
                self.skillArr:add(item);
            end
            item:setData(info[i]);
            item:setShowLevel(false);
            local x = -1 * skilWidth * #info / 2 + skilWidth * (i-1) + skilWidth / 2;
            item:setLocation(x-offectX, 331, 0);
            item:setEnable(true);
        end
    else
        if self.skillArr ~= nil then
            local len = self.skillArr:getSize();
            for i = 1, len do
                self.skillArr[i]:setEnable(false);
            end
        end
    end

	if bConnect then
        if self.planSkillItem == nil then
            self.planSkillItem = Lua_HeroSkillItem.new(self.content);--连携技能
            self.planSkillItem:setRectAnchor(7);
            self.planSkillItem:setLocation(272,331,0);
        end
        self.planSkillItem:setEnable(true);
        self.planSkillItem:setConnectData(hvo);
    else
        if self.planSkillItem ~= nil then
            self.planSkillItem:setEnable(false);
        end
    end
    self:showLine(bConnect);
end

--连携封线
function Lua_RecruitShowSingleHeroWindow:showLine(bool)
	if bool then
		if self.lineSpr == nil then
			self.lineSpr = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_line_008", 220, 328, 1, 118);
			self.lineSpr:setAnchorMin(0.5, 0);
    		self.lineSpr:setAnchorMax(0.5, 0);
		end
		self.lineSpr:setEnable(true);
	else
		if self.lineSpr ~= nil then
			self.lineSpr:setEnable(false);
		end
	end
end

function Lua_RecruitShowSingleHeroWindow:showModel(vo)
	if self.modelScenePanel == nil then
		self.modelScenePanel = Lua_ModelScenePanel.new()
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
	end

	if self.bInitModel or not self.modelScenePanel.bShowModel then
		self.modelScenePanel:setModelDir(vo.uiModelDir)
		self.modelScenePanel:setModelScale(vo.uiModelScale)
		self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, vo.poseActEffs)
		self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, vo.showActEffs)
		self.modelScenePanel:showModelScene(vo.uiSceneId, vo.uiModelUrl, vo.uiModelAvatarName, vo.uiModelCamController)
		self.modelScenePanel:setModelAct(vo.uiShowAct, Lua_ThingDefine.UIWAIT, true)
		self.modelScenePanel:addModelCallBack(self, self.onModelLoaded, nil)
	end
	 self.bInitModel = true
end

function Lua_RecruitShowSingleHeroWindow:onModelLoaded()
	if self.data == nil then
		return;
	end
	self:showHeroInfo(self.data);
end

-- 克制描述
function Lua_RecruitShowSingleHeroWindow:onCompBtnClick()
	local hvo = self.showData
	if self.showData.heroArr ~= nil or self.showData.trialTime ~= nil then
		hvo = self.showData.heroVo;
	end
    Lua_WindowUtil.openWin("Lua_HeroCampDesTipsWindow", Lua_WinParam.ACTION_OPEN, {des = DataCenter.heroUtil:getCampDic(hvo.campType), pos = {0, 520 + self.adaptHeight/2}});
end

function Lua_RecruitShowSingleHeroWindow:onQualityBtnClick()
	local hvo = self.showData
	if self.showData.heroArr ~= nil or self.showData.trialTime ~= nil then
		hvo = self.showData.heroVo;
	end
    Lua_WindowUtil.openWin("Lua_HeroCampDesTipsWindow", Lua_WinParam.ACTION_OPEN, {des = LanUtil.getValue(126068 + hvo.quality), pos = {0, 520 + self.adaptHeight/2}});
end

function Lua_RecruitShowSingleHeroWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.onDelay);
	DataCenter.guideData:removeShowModel(self.windowName); -- 引导用
	if self.modelScenePanel ~= nil then
		self.modelScenePanel:dispose()
		self.modelScenePanel = nil
	end
	if self.starInfo then
		self.starInfo:dispose();
		self.starInfo = nil;
	end
	if self.star_bg then
		self.star_bg:dispose();
		self.star_bg = nil;
	end
	if self.star_level then
		self.star_level:dispose();
		self.star_level = nil;
	end
	if self.skillArr then
		self.skillArr:dispose();
		self.skillArr = nil;
	end
	if self.showData and self.showData.heroArr then
		self.showData.heroArr:clear()
		self.showData.heroArr = nil;
	end

	if self.planSkillItem ~= nil then
        self.planSkillItem:dispose();
        self.planSkillItem = nil;
    end
    self.des_txt = nil;
    self.time_txt = nil;
    self.lineSpr = nil;
	self.data = nil;
	self:removeTimer(self, self.onTrialTimer);
	Lua_MsgUtil.callFunc("SINGLE_HERO_WIN_HIDE");
	self:superCall("dispose");
end

