-- 小卖部招募动画
Lua_RecruitTweenState = class("Lua_RecruitTweenState");
function Lua_RecruitTweenState.addTweenObj(tweenObj)
	if tweenObj == nil then
		return nil;
	end
	
	if Lua_RecruitTweenState.tweenObjDir == nil then
		Lua_RecruitTweenState.tweenObjDir = {};
	end

	local objName = tweenObj.name;
	if objName ~= nil and Lua_RecruitTweenState.tweenObjDir[objName] == nil then
		local cfg = getConfig("recruit_tween", objName);
	    if cfg == nil then
	    	return nil;
	    end
		Lua_RecruitTweenState.tweenObjDir[objName] = Lua_RecruitTweenState.new(tweenObj, cfg.arr_value);

		local type = cfg.tweenType;
		if Lua_RecruitTweenState.tweenTypeDir == nil then
			Lua_RecruitTweenState.tweenTypeDir = {};
		end
		if Lua_RecruitTweenState.tweenTypeDir[type] == nil then
			Lua_RecruitTweenState.tweenTypeDir[type] = Array();
		end
		if Lua_RecruitTweenState.tweenTypeDir[type]:indexOf(objName) == -1 then
			-- print("addTween", objName)
			Lua_RecruitTweenState.tweenTypeDir[type]:add(objName);
		end
	end
end

function Lua_RecruitTweenState.playAllTweenByType(type, bBack)
	if Lua_RecruitTweenState.tweenTypeDir ~= nil and Lua_RecruitTweenState.tweenTypeDir[type] ~= nil then
		local tweenTypeArr = Lua_RecruitTweenState.tweenTypeDir[type];
		local len = tweenTypeArr:getSize();
		local tweenVo;
		local objName;
		for i = 1, len do
			objName = tweenTypeArr[i];
			tweenVo = Lua_RecruitTweenState.tweenObjDir[objName];
			if tweenVo ~= nil then
				-- print("play",objName)
				tweenVo:stopTween();
				tweenVo:playTween(bBack);
			end
		end
	end
end

function Lua_RecruitTweenState.stopAllTweenByType(type)
	if Lua_RecruitTweenState.tweenTypeDir ~= nil and Lua_RecruitTweenState.tweenTypeDir[type] ~= nil then
		local tweenTypeArr = Lua_RecruitTweenState.tweenTypeDir[type];
		local len = tweenTypeArr:getSize();
		local tweenVo;
		local objName;
		for i = 1, len do
			objName = tweenTypeArr[i];
			tweenVo = Lua_RecruitTweenState.tweenObjDir[objName];
			if tweenVo ~= nil then
				tweenVo:stopTween();
			end
		end
	end
end

function Lua_RecruitTweenState.removeTween(tweenObj, type)
	if tweenObj ~= nil then
		local tweenVo = Lua_RecruitTweenState.tweenObjDir[tweenObj.name];
		if tweenVo ~= nil then
			tweenVo:stopTween();
			tweenVo:dispose();
			tweenVo = nil;
			Lua_RecruitTweenState.tweenObjDir[tweenObj.name] = nil;

			if Lua_RecruitTweenState.tweenTypeDir and Lua_RecruitTweenState.tweenTypeDir[type] then
				local index = Lua_RecruitTweenState.tweenTypeDir[type]:indexOf(tweenObj.name);
				local isremove = Lua_RecruitTweenState.tweenTypeDir[type]:removeItem(tweenObj.name);
				-- print("move", isremove, Lua_RecruitTweenState.tweenTypeDir[type][index]);
			end
		end
	end
end


------
function Lua_RecruitTweenState:ctor(obj, tweenCfg)
	self:superCall("ctor");
	self.tweenObj = obj;
	self.tweenData = tweenCfg;
end

function Lua_RecruitTweenState:playTween(bBack)
	if self.tweenObj ~= nil and self.tweenData ~= nil then
		self:stopTween();
		local tweenType = self.tweenData[1];
		if tweenType == 1 then 
			local showTime  = self.tweenData[2];
			local delayTime = self.tweenData[3];
			local tPosX = bBack and self.tweenData[4][1] or self.tweenData[5][1];
			local tPosY = bBack and self.tweenData[4][2] or self.tweenData[5][2];
			local tPosZ = bBack and self.tweenData[4][3] or self.tweenData[5][3];
			local tRotX = bBack and self.tweenData[4][4] or self.tweenData[5][4];
			local tRotY = bBack and self.tweenData[4][5] or self.tweenData[5][5];
			local tRotZ = bBack and self.tweenData[4][6] or self.tweenData[5][6];
			local tScalX = bBack and self.tweenData[4][7] or self.tweenData[5][7];
			local tScalY = bBack and self.tweenData[4][8] or self.tweenData[5][8];
			local tScalZ = bBack and self.tweenData[4][9] or self.tweenData[5][9];

			TweenUtil.getInstance():addTween(self.tweenObj, showTime, delayTime, 
				tPosX, tPosY, tPosZ, 
				tRotX, tRotY, tRotZ, 
				tScalX, tScalY, tScalZ, 
				self, self.onTweenComplete, 0, delayTime > 0);
		else
			local isShow = self.tweenData[2] == 1;
			isShow = bBack and not isShow or isShow;
			self.tweenObj:SetActive(isShow);
		end
	end
end

function Lua_RecruitTweenState:onTweenComplete()
end

function Lua_RecruitTweenState:stopTween()
	if self.tweenObj ~= nil and self.tweenData ~= nil then
		TweenUtil.getInstance():stop(self.tweenObj);
	end
end

function Lua_RecruitTweenState:dispose()
	self:stopTween();
	self.tweenObj = nil;
end