--英雄召唤 心愿祝福Window
Lua_RecruitWishBlessWindow = class("Lua_RecruitWishBlessWindow", Lua_Window);
function Lua_RecruitWishBlessWindow:ctor()
	self:superCall("ctor");

	self.w = 700;
	self.h = 900;
	self.showClose = true;
	self.isClickClose = true;
	self.showBlackMask = true;
	self.windowName = "Lua_RecruitWishBlessWindow";
	self.skinName = "RecruitWishBlessWindow_skin";
end

function Lua_RecruitWishBlessWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.progressBar:setMaxValue(0);
	self.progressBar:setValue(0);
	-- 设置属性图标列表
	self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
    self.campSiftPanel:setLocation(-32, -377, 0);
    self.campSiftPanel:setSiftItem(66, "76645C", 30, 0.8);
    self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftInfo);
    self.campSiftPanel:setCallBack(self, self.onCampSelected);
    self.campSiftPanel:setSelected(Lua_HeroUtil.WATER_TYPE, true);

	self.dragList = Lua_DragList.new(self.content, 602, 265, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_RecruitWishBlessItem, 99, 130, 5);
	self.dragList:setCellSpacing(27, 5);
	self.dragList.canLongPress = true;
	self.dragList.longPressLimit = 0.4;
    self.dragList:setLocation(0, -195, 0);
    local tweenId = DataCenter.recruitUtil.recruitTweenId;
    self.dragList.tweenId = tweenId;

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(2, 164, 0);
	self.itemIcon:setScale(0.8, 0.8, 0.8);

	self.tipTxt:setLangValue(140329);
	self.heroSelectTipTxt:setLangValue(140330);

	self.downTipSp:addClickFuntion(self, self.onDownTipSpClick);
	-- self:addLuaEvent("SELECT_HERP_CAMP_TYPE", self, self.updateCampSelect); 
	self:addLuaEvent("UPDATE_RECRUIT_WISHBLESS_INFO", self, self.updateMsgInfo); 
	Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sWishBlessInfo();
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.RecruitTabHighWishBless, false); -- 打开后关闭红点
end

function Lua_RecruitWishBlessWindow:dispose()
	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end

-- function Lua_RecruitWishBlessWindow:updateCampSelect(campType)
-- 	if self.campType == campType then return end
-- 	self.campType = campType;
-- 	self:updateCampShow(campType);
-- end

function Lua_RecruitWishBlessWindow:updateCampShow(campType)
	local arr = DataCenter.recruitUtil:getWishListHeroArr(campType);
	self.dragList:setArrayData(arr);
end

function Lua_RecruitWishBlessWindow:updateMsgInfo(msg)
	local blessHeroId = DataCenter.recruitData.blessHeroId;
	local heroConfig = Lua_HeroConfigData.getConfig(blessHeroId);
	if heroConfig ~= nil then
		heroConfig.campType = heroConfig.camp;
		self.itemIcon:setData(heroConfig);
		self.itemIcon:setEnable(true);
	else
		self.itemIcon:setEnable(false);
	end
	self.progressBar:setMaxValue(msg.wish_limit);
	self.progressBar:setValue(msg.wish_num);
	self.progressBar:setText(msg.wish_num .. "/" .. msg.wish_limit);

	self.cumulativeTxt.text = LanUtil.formateStr(140331, msg.login_days, DataCenter.recruitUtil:getWishListConfig("keep_days"));
	self.downTipTxt.text = LanUtil.formateStr(140332, msg.wish_times);
	
	if self.selectedCampType == nil then
		self.selectedCampType = Lua_HeroUtil.WATER_TYPE;
	end
	self:updateCampShow(self.selectedCampType);
end

-- 更新阵营选择
function Lua_RecruitWishBlessWindow:onCampSelected(campType, isUpdate)
    if self.selectedCampType == campType and isUpdate ~= true then
        return;
    end
    self.selectedCampType = campType;

    if self.firstEnter ~= nil then 	
	    self.dragList.showTween = true;
	    self:updateCampShow(campType);
	else
	 	self.firstEnter = true;
	end
end

function Lua_RecruitWishBlessWindow:onDownTipSpClick()
	local tipData = { des = LanUtil.getValue(140342), posX = 1, posY = -1101 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end
























------------------------------------------------------------------------------
Lua_RecruitWishBlessItem = class("Lua_RecruitWishBlessItem", Lua_ListCell);
function Lua_RecruitWishBlessItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RecruitWishBlessItem:buildShowItem()
	self:superCall("buildShowItem");
	
	--英雄Item
	self.heroItem = Lua_ItemIcon.new(self.content);	
	self.heroItem:setLocation(0, 16);
	self.heroItem:setScale(0.8, 0.8, 0.8);

	--英雄背景及名称
	self.heroNameBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_tab_01", 0, -48, 100, 32);
	self.heroNameTxt = UICreate.createLabel(self.content, "", 0, -48, 100, 32, 22);
	self.heroNameTxt.colorStr = Lua_ColorDefine.transColorStr("76645c");
	self.heroNameTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.heroNameTxt.alignmentValue = 4;

	-- 未获得图标
	self.receivedSp = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_window_036", 0, 16, 0, 0);
	self.receivedSp:resetSize();
	self.receivedSp:setScale(0.8, 0.8, 0.8);

	-- 选中图标
	self.selectIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_window_014", 0, 16, 0, 0);
	self.selectIcon:setScale(0.8, 0.8, 0.8);
	self.selectIcon:setEnable(false)
end

function Lua_RecruitWishBlessItem:dispose()
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	if self.selectIcon ~= nil then
		self.selectIcon:dispose();
		self.selectIcon = nil;
	end
	if self.receivedSp ~= nil then
		self.receivedSp:dispose();
		self.receivedSp = nil;
	end
	if self.heroNameBg ~= nil then
		self.heroNameBg:dispose();
		self.heroNameBg = nil;
	end
	if self.heroNameTxt ~= nil then
		self.heroNameTxt:dispose();
		self.heroNameTxt = nil;
	end
	self:superCall("dispose");
end

function Lua_RecruitWishBlessItem:setData(data)
	self.data = data;

	self.heroItem:setData(data);
	self.heroItem:showText(2, nil);
	if not data.isHasHero then
		self.heroItem:showStar(0);
	end
	
	self.heroNameTxt.text = data.name;
	self.receivedSp:setEnable(not data.isHasHero);
	self.selectIcon:setEnable(DataCenter.recruitData.blessHeroId == data.id);
end

function Lua_RecruitWishBlessItem:onPressClick()
	if self.data.id ~= DataCenter.recruitData.blessHeroId then
		Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sChangeWishBless(self.data.id);
	end
end

function Lua_RecruitWishBlessItem:onLongPressClick()
	if self.data.isHasHero then
		local heroVo = DataCenter.heroData:getItemByUniqueId(self.data.unique_id);
		DataCenter.packUtil:showItemInfo(heroVo);
	end
end