--英雄召唤 心愿明星Item
Lua_RecruitWishHeroItem = class("Lua_RecruitWishHeroItem", Lua_DisplayObject);

function Lua_RecruitWishHeroItem:ctor(p, showType)
	self.showType = showType;
	self:superCall("ctor", p, "RecruitWishHeroItem_skin");
end

function Lua_RecruitWishHeroItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroItem = Lua_ItemIcon.new(self.content);
	-- self.heroItem:setSiblingIndex(0);
	self.heroItem:setScale(0.7, 0.7, 0.7);
	self.heroItem.iconBg:addClickFuntion(self, self.onHeroBgClick);
	self.tipIcon:addClickFuntion(self, self.onBgClick);
end

function Lua_RecruitWishHeroItem:dispose()
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	self:superCall("dispose");
end

function Lua_RecruitWishHeroItem:setData(data)
	self.data = data;
	if tonumber(data.value) ~= 0 then
		local heroVo = Lua_HeroVo.new(tonumber(data.value));
		self.heroItem:setEnable(true);
		self.heroItem:setData(heroVo);
		self.heroItem:showText(2, nil);
	else
		self.heroItem:setEnable(false);
	end

	self:updateHeroBg();
end

function Lua_RecruitWishHeroItem:onBgClick()
	if self.showType == 1 then
		local advTypeVo = DataCenter.recruitUtil:getRecTotVoById(Lua_RecruitData.SENIOR);
		local openNeedNum = DataCenter.recruitUtil:getWishListConfig("open_times");
		if advTypeVo == nil or advTypeVo.adv_draw_times < openNeedNum then
			if advTypeVo ~= nil then
				OperateAlert.show(LanUtil.formateStr(140339, openNeedNum - advTypeVo.adv_draw_times));
			end
			return;
		end
		Lua_WindowUtil.openWin("Lua_RecruitWishListWindow", Lua_WinParam.ACTION_OPEN);
	end
end

function Lua_RecruitWishHeroItem:onHeroBgClick()
	if self.showType == 2 then
		if tonumber(self.data.value) ~= 0 then
			if self.data.other == 2 then
				OperateAlert.showLangValue(140334);
				return;
			end
			DataCenter.recruitData:setSelectWishInfo(self.data.key, 0);
			Lua_MsgUtil.callFunc("UPDATE_WISHLIST_HERO_SELECT");
		end
	else
		self:onBgClick();
	end
end

function Lua_RecruitWishHeroItem:updateHeroBg()
	local isBecamingGray = tonumber(self.data.value) ~= 0 and self.data.other == 2;
	self.heroItem:setGray(isBecamingGray);
	self.heroItem.iconBg.clickScale = not isBecamingGray;
end