--英雄召唤 心愿单Window
checkRequire("Lua_RecruitWishHeroItem");
Lua_RecruitWishListWindow = class("Lua_RecruitWishListWindow", Lua_Window);

function Lua_RecruitWishListWindow:ctor()
	self:superCall("ctor");

	self.w = 700;
	self.h = 900;
	self.showClose = true;
	self.isClickClose = true;
	self.showBlackMask = true;
   self.skinName = "RecruitWishListWindow_skin";
	self.windowName = "Lua_RecruitWishListWindow";
end

function Lua_RecruitWishListWindow:buildShowItem()
	self:superCall("buildShowItem");

	-- 设置属性图标
	self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
	self.campSiftPanel:setLocation(-32, -342, 0);
	self.campSiftPanel:setSiftItem(66, "726763", 28, 0.9);
	self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftInfo);
	self.campSiftPanel:setCallBack(self, self.onCampSelected);
	self.campSiftPanel:setSelected(Lua_HeroUtil.WATER_TYPE, true);

	self.dragList = Lua_DragList.new(self.content, 602, 256, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_RecruitWishListItem, 99, 130, 5);
	self.dragList:setCellSpacing(27, 5);
	self.dragList.canLongPress = true;
   self.dragList:setLocation(0, -156, 0);
   local tweenId = DataCenter.recruitUtil.recruitTweenId;
   self.dragList.tweenId = tweenId;

   -- 确定按钮
   self.sureBtn:addClickFuntion(self, self.onSureBtnClick);

   local openHeatState = DataCenter.funcOpenData:isOpened(DataCenter.heroHeatUtil.heat_func_id,false);
   self.hotHeroSp:setEnable(openHeatState);
   self.hotHeroSp:addClickFuntion(self, self.onHotHeroSpClick);

	--文本
	self.sureBtn:setLangValue(140333);
	self.tipTxt:setLangValue(140341);
	-- self.tipTxt:setLocation(-317, 338);
	self.heroSelectTipTxt:setLangValue(140330);
	self.btnClose:setLocation(321, 407);

	-- self:addLuaEvent("SELECT_HERP_CAMP_TYPE", self, self.updateCampSelect); 
	self:addLuaEvent("UPDATE_RECRUIT_WISHLIST_INFO", self, self.updateData); 
	self:addLuaEvent("UPDATE_WISHLIST_HERO_SELECT", self, self.updateData); 
   Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sWishListInfo();
end

function Lua_RecruitWishListWindow:dispose()
	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_RecruitWishListWindow:updateCampShow(campType)
	local arr = DataCenter.recruitUtil:getWishListHeroArr(campType);
	self.dragList:setArrayData(arr);
end

function Lua_RecruitWishListWindow:updateData()
	if self.wishHeroArr == nil then
		self.wishHeroArr = Array();
	end

	local item;
	local wishListInfo = DataCenter.recruitData.wishSelectList;
	for i = 1, DataCenter.recruitUtil:getWishListConfig("amount") do
		item = self.wishHeroArr[i];
		if item == nil then
			item = Lua_RecruitWishHeroItem.new(self.content, 2);
			item.tipIcon:setEnable(false);
			item.heroItem:setScale(0.8, 0.8, 0.8);
			item:setLocation(-196 + (i - 1) * 202, 156, 0);
			self.wishHeroArr:add(item);
		end
		item:setData(wishListInfo[i]);
	end

	-- local camp = self.campType;
	if self.selectedCampType == nil then
		self.selectedCampType = Lua_HeroUtil.WATER_TYPE;
	end
	self:updateCampShow(self.selectedCampType);
end

function Lua_RecruitWishListWindow:onSureBtnClick()
	Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sAddWishList(DataCenter.recruitData.wishSelectList);
	self:hide();
end

--英雄热度
function Lua_RecruitWishListWindow:onHotHeroSpClick()
	DataCenter.funcPathUtil:gotoFunction(1082,true);
end

-- 更新阵营选择
function Lua_RecruitWishListWindow:onCampSelected(campType, isUpdate)
   if self.selectedCampType == campType and isUpdate ~= true then
      return;
   end
   self.selectedCampType = campType;
   
   if self.firstEnter ~= nil then 	
      self.dragList.showTween = true;
	   self:updateCampShow(campType);
	else
	   self.firstEnter = true;
	end
end































------------------------------------------------------------------------

Lua_RecruitWishListItem = class("Lua_RecruitWishListItem", Lua_ListCell);
function Lua_RecruitWishListItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RecruitWishListItem:buildShowItem()
	self:superCall("buildShowItem");

	--英雄Item
	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setLocation(0, 16);
	self.heroItem:setScale(0.8, 0.8, 0.8);

	--英雄背景及名称
	self.heroNameBg = UICreate.createUIAtlasImage(self.content, "recruit_atlas_3", "xui_rdb_tab_1", 0, -48, 100, 32);
	self.heroNameTxt = UICreate.createLabel(self.content, "", 0, -48, 100, 32, 19);
	self.heroNameTxt.colorStr = Lua_ColorDefine.transColorStr("76645c");
	self.heroNameTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.heroNameTxt.alignmentValue = 4;

	-- 未获得图标
	self.receivedSp = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_window_036", 0, 16, 0, 0);
	self.receivedSp:resetSize();
	self.receivedSp:setScale(0.8, 0.8, 0.8);

	-- 选中图标
	self.selectIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_window_014", 0, 16, 0, 0);
	self.selectIcon:setScale(0.8, 0.8, 0.8);
	self.selectIcon:setEnable(false);
end

function Lua_RecruitWishListItem:dispose()
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	if self.selectIcon ~= nil then
		self.selectIcon:dispose();
		self.selectIcon = nil;
	end
	if self.heroNameBg ~= nil then
		self.heroNameBg:dispose();
		self.heroNameBg = nil;
	end
	if self.receivedSp ~= nil then
		self.receivedSp:dispose();
		self.receivedSp = nil;
	end
	if self.heroNameTxt ~= nil then
		self.heroNameTxt:dispose();
		self.heroNameTxt = nil;
	end
	self:superCall("dispose");
end

function Lua_RecruitWishListItem:setData(data)
	self.data = data;

	self.heroItem:setData(data);
	self.heroItem:showText(2, nil);
	self.receivedSp:setEnable(not data.isHasHero);

	if not data.isHasHero then
		self.heroItem:showStar(0);
	end

	self.wishInfo = DataCenter.recruitData:getWishInfo(data.id);
	self.selectIcon:setEnable(self.wishInfo ~= nil);
	self.heroNameTxt.text = data.name;
end

function Lua_RecruitWishListItem:onPressClick()
	if self.wishInfo ~= nil then
		if self.wishInfo.other == 2 then
			OperateAlert.showLangValue(140334);
			return;
		end
		DataCenter.recruitData:setSelectWishInfo(self.wishInfo.key, 0);
	else
		if DataCenter.recruitData:isInWishCamp(self.data.campType) then
			OperateAlert.showLangValue(140335);
			return;
		end

		local index = DataCenter.recruitData.isWishListFree;
		if index == nil then
			OperateAlert.showLangValue(140336);
			return;
		end
		DataCenter.recruitData:setSelectWishInfo(index, self.data.id);
	end
	Lua_MsgUtil.callFunc("UPDATE_WISHLIST_HERO_SELECT");
end

function Lua_RecruitWishListItem:onLongPressClick()
	if self.data.isHasHero then
		local heroVo = DataCenter.heroData:getItemByUniqueId(self.data.unique_id);
		DataCenter.packUtil:showItemInfo(heroVo);
	end
end