Lua_RecruitExchangeItemWindow = class("Lua_RecruitExchangeItemWindow", Lua_Window);
function Lua_RecruitExchangeItemWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_RecruitExchangeItemWindow";
	self.skinName = "RecruitExchangeItemWindow_skin";
	self.showClose = true;
	self.showBlackMask = true
	self.isClickClose = true;
end

function Lua_RecruitExchangeItemWindow:buildShowItem()
	self:superCall("buildShowItem");


	local idList = DataCenter.recruitUtil:getRecTotVoById(Lua_RecruitData.SCOUT).exhibitionItem;
   self.cashId = idList[2]; -- 兑换道具id

	self.btnClose:setLocation(319, 406);
	self.dragList = Lua_DragList.new(self.content, 611, 561, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_RecruitExchangeItem, 108, 147, 5);
	self.dragList:setCellSpacing(18, 11);
	-- self.dragList.canLongPress = true;
   self.dragList:setLocation(-2, -39, 0);

	self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
	self.campSiftPanel:setLocation(-32, -376, 0);
	self.campSiftPanel:setSiftItem(66, "726763", 28, 0.9);
	self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
	self.campSiftPanel:setCallBack(self, self.onCampSelected);
	self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);

	self:showCostItem();
	self:addLuaEvent("RECRUIT_EXCHANGEITEM_UPDATECOUNT", self, self.updateItemCount);--获取货币更新红点
end

function Lua_RecruitExchangeItemWindow:updateItemCount(count)
	if count ~= nil then 
	   self.shopCountTxt.text = count;
	end
end

-- 更新阵营选择
function Lua_RecruitExchangeItemWindow:onCampSelected(campType)
   if self.selectedCampType == campType then
      return;
   end
   self.selectedCampType = campType;

   local list = DataCenter.recruitUtil:getExchangeIdListByType(campType);
	self.dragList:setArrayData(list);
	self.dragList:moveToIndex(1);
end

function Lua_RecruitExchangeItemWindow:showCostItem()
    local vo = Lua_ToolVo.new(self.cashId);
    self.shopItemSp:setAltas(vo.iconAtlas, vo.iconSprite);
    self.shopCountTxt.text = DataCenter.packData:getItemCountById(self.cashId);
end

function Lua_RecruitExchangeItemWindow:dispose()
	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end
	self:superCall("dispose");
end





















Lua_RecruitExchangeItem = class("Lua_RecruitExchangeItem", Lua_ListCell);
function Lua_RecruitExchangeItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RecruitExchangeItem:buildShowItem()
	self:superCall("buildShowItem");

	--英雄Item
	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setLocation(0, 22);
	self.heroItem:setScale(0.8, 0.8, 0.8);

	--英雄背景及名称
	self.iconBg = UICreate.createUIAtlasImage(self.content, "recruit_atlas_3", "xui_xmb_widget_06", -1, -49, 96, 27);

	-- 道具Item
	self.costSp = UICreate.createUIAtlasImage(self.content, nil, nil, -33, -47, 64, 72);
	self.costSp:setScale(0.6, 0.6, 0.6);

	self.costCountTxt = UICreate.createLabel(self.content, "", 19, -52, 66, 32, 22);
	self.costCountTxt.colorStr = Lua_ColorDefine.transColorStr("FFFFFF");
	self.costCountTxt.fontName = Lua_MyUISettings.defaultFontName;
	self.costCountTxt.alignmentValue = 0;
end

function Lua_RecruitExchangeItem:setData(data)
	if data == nil then
		return;
	end
	self.data = data;

	local info = DataCenter.recruitUtil:getExchangeItemInfoById(data);
	local tvo = Lua_ToolVo.createToolVo(info.id, info.count);
	self.heroItem:setData(tvo);

	tvo = Lua_ToolVo.createToolVo(info.costItem[1][1]);
	self.costSp:setAltas(tvo.iconAtlas, tvo.iconSprite);
	self.costCountTxt.text = info.costItem[1][2];
end

function Lua_RecruitExchangeItem:onPressClick()
	if not DataCenter.heroData:isBagEnough(1) then
		OperateAlert.showLangValue(140371);
		return;
	end

	local info = DataCenter.recruitUtil:getExchangeItemInfoById(self.data);
	local costId, costCount = info.costItem[1][1], info.costItem[1][2];
	local isOpen = DataCenter.packData:getItemCountById(costId) >= costCount;
	if isOpen then
		local data = {itemVo = Lua_ToolVo.createToolVo(info.id), leftTimes = 0, moneyType = costId, moneyCount = costCount, isExchangeShop = true};
		Lua_WindowUtil.openWin("Lua_BuyGoodsWindow", Lua_WinParam.ACTION_OPEN, data);
	else
		DataCenter.packUtil:openPathWindow(costId);
	end
end

function Lua_RecruitExchangeItem:dispose()
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	if self.costSp ~= nil then
		self.costSp:dispose();
		self.costSp = nil;
	end
	if self.costCountTxt ~= nil then
		self.costCountTxt:dispose();
		self.costCountTxt = nil;
	end
	self:superCall("dispose");
end