--盲盒机 概率显示界面
Lua_RecruitProbabilityWindow = class("Lua_RecruitProbabilityWindow", Lua_Window);
function Lua_RecruitProbabilityWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_RecruitProbabilityWindow";
	self.isClickClose = true;
	self.showBlackMask = true;
	self.showCloseText = true;
	self.closeTextPosY = -418;
end

function Lua_RecruitProbabilityWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.heroRateBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_window_009", 0, -48, 523, 660);
	self.heroRateBg.siblingIndex = 0;

	self.heroProbabilityTxt = UICreate.createLabel(self.content, LanUtil.getValue(140352), 0, 226, 100, 32, 26);
	self.heroProbabilityTxt.colorStr = Lua_ColorDefine.transColorStr("D1B61C");
	self.heroProbabilityTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.heroProbabilityTxt.alignmentValue = 4;
	self.heroProbabilityTxt.horizontalOverflowValue = 1;

	self.rewardHeroList = Lua_DragList.new(self.content, 490, 487, Lua_AxisDefine.Vertical);
	self.rewardHeroList:setLocation(0, -67, 0);
   	self.rewardHeroList:setListCell(Lua_RecruitHeroItem, 99, 130, 5);
end

function Lua_RecruitProbabilityWindow:showWin(param)
 	local rateConfig = DataCenter.recruitUtil.rate_table[param]
	if rateConfig == nil then
		return 
	end
	self.rewardHeroList:setArrayData(rateConfig.rateList);
end

function Lua_RecruitProbabilityWindow:dispose()
	if self.rewardHeroList ~= nil then
		self.rewardHeroList:dispose();
		self.rewardHeroList = nil;
	end
	if self.heroRateBg ~= nil then
		self.heroRateBg:dispose();
		self.heroRateBg = nil;
	end
	if self.heroProbabilityTxt ~= nil then
		self.heroProbabilityTxt:dispose();
		self.heroProbabilityTxt = nil;
	end

	self:superCall("dispose");
end















-------------------------------------------------------------------------------


Lua_RecruitHeroItem = class("Lua_RecruitHeroItem", Lua_ListCell);
function Lua_RecruitHeroItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RecruitHeroItem:buildShowItem()
	self:superCall("buildShowItem");
	
	--英雄Item
	self.heroItem = Lua_ItemIcon.new(self.content);	
	self.heroItem:setLocation(0, 16);
	self.heroItem:setScale(0.8, 0.8, 0.8);

	--英雄背景及名称
	self.heroProbabilityTxt = UICreate.createLabel(self.content, nil, 0, -48, 100, 32, 22);
	-- self.heroProbabilityTxt.colorStr = Lua_ColorDefine.transColorStr("76645c");
	self.heroProbabilityTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.heroProbabilityTxt.alignmentValue = 4;
end

function Lua_RecruitHeroItem:dispose()
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	if self.heroProbabilityTxt ~= nil then
		self.heroProbabilityTxt:dispose();
		self.heroProbabilityTxt = nil;
	end
	self:superCall("dispose");
end

function Lua_RecruitHeroItem:setData(data)
	self.data = data;
	local tvo = Lua_ToolVo.createToolVo(data.itemId, data.itemCount);
	self.heroItem:setData(tvo);
	self.heroItem:showText(2, nil);
	
	self.heroProbabilityTxt.text = data.itemRate;
end

function Lua_RecruitHeroItem:onPressClick()
	if self.data ~= nil then
		local tvo = Lua_ToolVo.createToolVo(self.data.itemId);
		DataCenter.packUtil:showItemInfo(tvo);
	end
end