--先知召唤Item
Lua_RecruitScoutItem = class("Lua_RecruitScoutItem", Lua_DisplayObject);
function Lua_RecruitScoutItem:ctor(p)
    self:superCall("ctor", p, "RecruitScoutItem_skin");
end

function Lua_RecruitScoutItem:buildShowItem()
    self:superCall("buildShowItem");
    self.owner = nil;
    self.callBack = nil;

    self.scoutItemBgWidth_1 = 218;
    self.scoutItemBgWidth_2 = 210;
    self.scoutItemBgHeight = 240;

    self.lightSp:setEnable(false);
    self.scoutItemLightSp:setEnable(false);

    self.scoutItemBg.clickScale = false;
    self.scoutItemBg:addClickFuntion(self, self.onItemClick);
    self.viewBtn:addClickFuntion(self, self.onViewClick);
end

function Lua_RecruitScoutItem:setData(data)
    self.data = data;
    self.type = data.type;
    local str;
    local posX;
    self.scoutItemBg:setAltas("recruit_atlas_2", data.sprite);

    if data.scout_sort % 2 == 0 then
        str = "10";
        posX = 10;
        self.scoutItemBgWidth = self.scoutItemBgWidth_2;
    else
        str = "09";
        posX = 13;
        self.scoutItemBgWidth = self.scoutItemBgWidth_1;
    end
    self.scoutItemBg:SetDimensions(self.scoutItemBgWidth * 0.8, self.scoutItemBgHeight * 0.8);

    local spriteStr = "xui_mhj_widget_"..str;
    self.scoutItemLightSp:setAltas("recruit_atlas_2", spriteStr);
    self.scoutItemLightSp:setLocation(posX, 160);
    self.scoutItemLightSp:resetSize();
end

function Lua_RecruitScoutItem:onViewClick()
    if DataCenter.recruitData.onBtnControl then--按钮点击控制
        return;
    end
    Lua_WindowUtil.openWin("Lua_RecruitProbabilityWindow", Lua_WinParam.ACTION_OPEN, self.type)
end

function Lua_RecruitScoutItem:onItemClick()
    if DataCenter.recruitData.onBtnControl then--按钮点击控制
        return;
    end
    if self.owner~=nil and self.callBack~=nil then
        self.callBack(self.owner,self.data)
    end
end

function Lua_RecruitScoutItem:onSelect(bSelect)
    if bSelect then
        self.scoutItemBg:SetDimensions(self.scoutItemBgWidth * 0.9, self.scoutItemBgHeight * 0.9);
    else
        self.scoutItemBg:SetDimensions(self.scoutItemBgWidth * 0.8, self.scoutItemBgHeight * 0.8);
    end
    self.lightSp:setEnable(bSelect);
    self.scoutItemLightSp:setEnable(bSelect);
end

function Lua_RecruitScoutItem:dispose()
    self.data = nil;
    self.owner = nil;
    self.callBack = nil;
    self:superCall("dispose");
end