--召唤系统 先知召唤
checkRequire("Lua_RecruitScoutItem");
Lua_RecruitScoutPanel = class("Lua_RecruitScoutPanel", Lua_DisplayObject);
function Lua_RecruitScoutPanel:ctor(p)
    self:superCall("ctor", p, "RecruitScoutPanel_skin");
end

function Lua_RecruitScoutPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.winBg:setUrl("/images/recruit/xui_mhj_bg_001.png");
    self.shopTxt:setLangValue(140350);
    DataCenter.recruitData.selectType = Lua_RecruitData.SCOUT;

    local typesPos = {{-206, 720}, {16, 720}, {-206, 435}, {16, 433}};
    local typeInfoList = DataCenter.recruitUtil.type_list;
    self.scoutItemList = Array();
    for i = 1, #typesPos do
        local scoutItem = Lua_RecruitScoutItem.new(self.content)
        scoutItem:setLocation(typesPos[i][1], typesPos[i][2], 0);
        scoutItem:setData(typeInfoList[i])
        scoutItem:setSiblingIndex(1);
        scoutItem:setRectAnchor(7);
        scoutItem.owner = self
        scoutItem.callBack = self.clickBack
        self.scoutItemList:add(scoutItem)
    end

    self.scaleFactor = -0.05;
    self.oneBtnBg.clickScaleVal = self.scaleFactor;
    self.tenBtnBg.clickScaleVal = self.scaleFactor;
    
    self:updateCostItemShow();
    self:rRecruitScout();
    self.shopIcon:addClickFuntion(self, self.onShopIconClick);

    self:addLuaEvent("MONEY_UPDATE", self, self.updateShowItemNum); 
    self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.updateShowItemNum);
    self:addLuaEvent("UPDATE_RECRUITSCOUT_ITEM", self, self.updateShowItemNum);
    self:addLuaEvent("CALL_RECRUIT_END", self, self.showRecruitEnd);
    self:addLuaEvent("SCOUT_RECRUIT_AGAIN", self, self.recruitAgain);
end

function Lua_RecruitScoutPanel:onShopIconClick()
    -- DataCenter.funcPathUtil:gotoFunction(1073) -- 1073:盲盒机商店跳转id
    Lua_WindowUtil.openWin("Lua_RecruitExchangeItemWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_RecruitScoutPanel:updateCostItemShow()
    local idList = DataCenter.recruitUtil:getRecTotVoById(Lua_RecruitData.SCOUT).exhibitionItem;
    self.costId = idList[1]; -- 抽奖消耗道具id
    local vo = Lua_ToolVo.new(self.costId);
    self.hasItemSp:setAltas(vo.iconAtlas, vo.iconSprite);
    self.hasNumTxt.text = DataCenter.packData:getItemCountById(self.costId);

    self.cashId = idList[2]; -- 兑换道具id
    vo = Lua_ToolVo.new(self.cashId);
    self.shopItemSp:setAltas(vo.iconAtlas, vo.iconSprite);
    self.itemNumTxt.text = DataCenter.packData:getItemCountById(self.cashId);
end

function Lua_RecruitScoutPanel:rRecruitScout()
    self.scoutInfo = DataCenter.recruitUtil:getRecTotVoById(Lua_RecruitData.SCOUT);

    local toolVo = Lua_ToolVo.createToolVo(self.scoutInfo.costId);
    self.oneBtnClIcon:setAltas(toolVo.atlas, toolVo.sprite);
    self.tenBtnClIcon:setAltas(toolVo.atlas, toolVo.sprite);

    self.oneBtnBg:addClickFuntion(self, self.onOneBtnClick);
    self.oneBtnBg:addMouseUpFuntion(self, self.onOneBtnMouseUp);
    self.oneBtnBg:addMousDownFuntion(self, self.onOneBtnMouseDown);

    self.tenBtnBg:addClickFuntion(self, self.onTenBtnClick);
    self.tenBtnBg:addMouseUpFuntion(self, self.onTenBtnBgMouseUp);
    self.tenBtnBg:addMousDownFuntion(self, self.onTenBtnBgMouseDown);
end

function Lua_RecruitScoutPanel:clickBack(data)
    if self.selectType == tonumber(data.type) then
        return 
    end

    self.selectType = tonumber(data.type)
    for i = 1, self.scoutItemList:getSize() do
        if tonumber(self.scoutItemList[i].data.type) == tonumber(data.type) then
            self.scoutItemList[i]:onSelect(true)
        else
            self.scoutItemList[i]:onSelect(false)
        end
    end
end

function Lua_RecruitScoutPanel:onOneBtnClick()
    DataCenter.recruitData.selectTimes = self.scoutInfo.oneCost;
    self:onRecruitClick();
end

function Lua_RecruitScoutPanel:onTenBtnClick()
    DataCenter.recruitData.selectTimes = self.scoutInfo.tenCost;
    self:onRecruitClick();
end

function Lua_RecruitScoutPanel:recruitAgain(type)
    if type == 1 then
        self:onOneBtnClick();
    else
        self:onTenBtnClick();
    end
end

function Lua_RecruitScoutPanel:onOneBtnMouseUp()
    self.oneBtnClIcon:setScale(1, 1);
    self.oneBtnClIcon:setLocation(-206, 235);
end

function Lua_RecruitScoutPanel:onOneBtnMouseDown()
    self.oneBtnClIcon:setScale(1 + self.scaleFactor , 1 + self.scaleFactor);

    local posX, posY = -206 + (-206 - -138) * self.scaleFactor, 235;
    self.oneBtnClIcon:setLocation(posX, posY);
end

function Lua_RecruitScoutPanel:onTenBtnBgMouseUp()
    self.tenBtnClIcon:setScale(1, 1);
    self.tenBtnClIcon:setLocation(24, 235);
end

function Lua_RecruitScoutPanel:onTenBtnBgMouseDown()
    self.tenBtnClIcon:setScale(1 + self.scaleFactor , 1 + self.scaleFactor);

    local posX, posY = 24 + (24 - 133) * self.scaleFactor, 235;
    self.tenBtnClIcon:setLocation(posX, posY);
end

function Lua_RecruitScoutPanel:onRecruitClick()
    if self.selectType == nil or self.selectType <= 0 then
        OperateAlert.showLangValue(140306);
        return;
    end

    local toolNum = DataCenter.packData:getItemCountById(self.scoutInfo.costId);
    if toolNum < DataCenter.recruitData.selectTimes then
        DataCenter.packUtil:openPathWindow(self.scoutInfo.costId, false);
    else
        DataCenter.recruitData.scoutSelect = self.selectType;
        self:startDrawingReward();
    end
end

function Lua_RecruitScoutPanel:updateShowItemNum(dic)
    if dic ~= nil then -- 道具数量增加时
        if dic.isUpdate or (self.costId ~= nil and dic[self.costId] ~= nil) then
            self.hasNumTxt.text = DataCenter.packData:getItemCountById(self.costId);
        end

        if dic.isUpdate or (self.cashId and dic[self.cashId] ~= nil) then
            self.itemNumTxt.text = DataCenter.packData:getItemCountById(self.cashId);
        end
    end
end

function Lua_RecruitScoutPanel:sendMessageToServer()
    Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sRecruitStar(self.scoutInfo.type, self.selectType * 100 + DataCenter.recruitData.selectTimes);
end 

function Lua_RecruitScoutPanel:startDrawingReward()
    self:showEffect(true);
    local time = DataCenter.recruitUtil.scoutDelayTime;
    Lua_CommonUtil.delayCall(time, self, self.sendMessageToServer);
    Lua_MsgUtil.callFunc("RECRUIT_OPEN_MASK", true); --盲盒机招募时遮罩
end

function Lua_RecruitScoutPanel:showEffect(bShow)
    if bShow then
        if self.uiEffect == nil then
            self.uiEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_manghe", "ui_manghe", 0, 720);
            self.uiEffect.anchorValue = 7;
        end
        self.uiEffect:setEnable(true);
    else
        if self.uiEffect ~= nil then
            self.uiEffect:setEnable(false);
        end
    end
end

function Lua_RecruitScoutPanel:showRecruitEnd()
    Lua_MsgUtil.callFunc("RECRUIT_OPEN_MASK", false); --盲盒机招募时遮罩
    self:showEffect(false);
end

function Lua_RecruitScoutPanel:dispose()
    Lua_CommonUtil.removeTimer(self, self.sendMessageToServer);
    if self.scoutItemList ~= nil then
        self.scoutItemList:dispose();
        self.scoutItemList:clear();
        self.scoutItemList = nil;
    end
    if self.costItemArr ~= nil then
        self.costItemArr:dispose();
        self.costItemArr = nil;
    end
    if self.uiEffect ~= nil then
        self.uiEffect:dispose();
        self.uiEffect = nil;
    end
    self:superCall("dispose");
end